/* BLOCCU.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static real c_b9 = (float)-1.;
static real c_b10 = (float)1.;

/* Subroutine */ int bloccu_(xfd, pkc, rot, nap, bne, bnh, pol, block, xb, 
	lunit)
real *xfd, *pkc, *rot;
integer *nap;
real *bne, *bnh, *pol;
doublereal (*block) ();
real *xb;
integer *lunit;
{
    /* Initialized data */

    static real zz = (float)376.73;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();
    double cos(), sin();

    /* Local variables */
#define frec ((real *)equiv_2)
    static complex ephi;
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static complex unit[3];
    static integer i__, j, l;
    static real phase;
    extern /* Subroutine */ int vlinc_(), retsp_();
    static complex efield[3], hfield[3];
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int ffdirc_();
    static real sp[3], vp[3], vr[3], vt[3];
    static complex etheta;
    extern /* Subroutine */ int rcspat_(), ccross_();
    static complex pha;
    static real xfr[3];

    /* Fortran I/O blocks */
    static cilist io___7 = { 0, 0, 0, 0, 1 };
    static cilist io___9 = { 0, 0, 0, 0, 1 };
    static cilist io___11 = { 0, 0, 0, 0, 0 };
    static cilist io___26 = { 0, 0, 0, 0, 0 };



/*  Blockage surface currents added to Geometry File */
/*  for cosine pattern approximation */

/*  XFD(3)   Location of feed */
/*  PKC      Propagation constant */

/*  Rotated */
/*  Pattern approximation  I: E = cos(Theta/2)**N */
/*                        II: E = cos(Theta)**N */

/*  ROT(3,3) Rotation matrix */
/*  NAP      Pattern approximation number */
/*  BNE      Exponent in E plane */
/*  BNH      Exponent in H plane */
/*  POL      Polarization: 0 Linear, -1 RHC, +1 LHC */
/*  BLOCK    Blockage function (external) = 1 when blocked */
/*  XB       Array of variables for blockage function */
/*  LUNIT    Logical unit of random access currents file */

    /* Parameter adjustments */
    --xb;
    rot -= 4;
    --xfd;

    /* Function Body */
    io___7.ciunit = *lunit;
    s_rdue(&io___7);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    *pk = *pkc;
    ibuf[1] = 0;
    io___9.ciunit = *lunit;
    s_wdue(&io___9);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/*  ------------- Loop over current patches */
    i__1 = ibuf[0];
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___11.ciunit = *lunit;
	io___11.cirec = i__ + 1;
	s_rdue(&io___11);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
/*  ------------- Check for feed blockage */
	if ((*block)(&xb[1], &xfd[1], frec) != (float)1.) {
/*  ------------- Find vector from feed to reflector point */
	    vlinc_(&c_b9, &xfd[1], &c_b10, frec, xfr);
	    retsp_(xfr, sp);
	    ffdirc_(&sp[1], &sp[2], vr, vt, vp);
/*  ------------- Find field */
	    rcspat_(&rot[4], nap, &sp[1], &sp[2], bne, bnh, pol, &etheta, &
		    ephi);
	    phase = -sp[0] * *pkc;
	    r__1 = cos(phase);
	    r__2 = sin(phase);
	    q__2.r = r__1, q__2.i = r__2;
	    q__1.r = q__2.r / sp[0], q__1.i = q__2.i / sp[0];
	    pha.r = q__1.r, pha.i = q__1.i;
	    for (l = 1; l <= 3; ++l) {
		i__2 = l - 1;
		r__1 = vr[l - 1] / zz;
		unit[i__2].r = r__1, unit[i__2].i = (float)0.;
/* L1: */
		i__2 = l - 1;
		i__3 = l - 1;
		q__3.r = vt[i__3] * etheta.r, q__3.i = vt[i__3] * etheta.i;
		i__4 = l - 1;
		q__4.r = vp[i__4] * ephi.r, q__4.i = vp[i__4] * ephi.i;
		q__2.r = q__3.r + q__4.r, q__2.i = q__3.i + q__4.i;
		q__1.r = q__2.r * pha.r - q__2.i * pha.i, q__1.i = q__2.r * 
			pha.i + q__2.i * pha.r;
		efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
	    }
	    ccross_(unit, efield, hfield);
	    for (j = 1; j <= 3; ++j) {
/* L2: */
		i__2 = j - 1;
		r__1 = frec[j + 3] * frec[3];
		unit[i__2].r = r__1, unit[i__2].i = (float)0.;
	    }
	    ccross_(unit, hfield, curj);
	    ccross_(efield, unit, curm);
	} else {
/*  ------------- Blocked */
	    for (j = 1; j <= 3; ++j) {
		i__2 = j - 1;
		curm[i__2].r = (float)0., curm[i__2].i = (float)0.;
/* L3: */
		i__2 = j - 1;
		curj[i__2].r = (float)0., curj[i__2].i = (float)0.;
	    }
	}
/* L4: */
	io___26.ciunit = *lunit;
	io___26.cirec = i__ + 1;
	s_wdue(&io___26);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* bloccu_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


