/* CMTMUL.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int cmtmul_(am, x, y)
complex *am, *x, *y;
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    complex q__1, q__2;

    /* Local variables */
    static integer i__, j;


/*  Matrix multiplication between Complex Matrix and Complex Vector */

/*  AM(3,3)   Complex matrix */
/*  X(3)      Complex vector */
/*  Y(3)      Resulting vector */

    /* Parameter adjustments */
    --y;
    --x;
    am -= 4;

    /* Function Body */
    for (i__ = 1; i__ <= 3; ++i__) {
	i__1 = i__;
	y[i__1].r = (float)0., y[i__1].i = (float)0.;
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    i__1 = i__;
	    i__2 = i__;
	    i__3 = i__ + j * 3;
	    i__4 = j;
	    q__2.r = am[i__3].r * x[i__4].r - am[i__3].i * x[i__4].i, q__2.i =
		     am[i__3].r * x[i__4].i + am[i__3].i * x[i__4].r;
	    q__1.r = y[i__2].r + q__2.r, q__1.i = y[i__2].i + q__2.i;
	    y[i__1].r = q__1.r, y[i__1].i = q__1.i;
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cmtmul_ */

