/* CURCOM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int curcom_(lunit)
integer *lunit;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static integer i__, j;
#define pk (equiv_0 + 2)
    static integer nn;

    /* Fortran I/O blocks */
    static cilist io___6 = { 0, 0, 0, 0, 1 };
    static cilist io___9 = { 0, 0, 0, 0, 0 };



/*  Read currents from file into CURRENT common */

/*  LUNIT    Logical unit of random access file (open file) */

/*  File:  76 Bytes record */

/*  Record 1 */

/*  Number of records */
/*  Types of currents available: 0 both, 1 electric only, 2 magnetic only 
*/
/*  Propagation constant (1./meters) */

/*  Record 2 - NCUR+1 */

/*  Position(3)   meters */
/*  Area          meters**2 */
/*  Normal(3)     Unit normal to patch */
/*  J(3)          Electric current * area */
/*  M(3)          Magnetic current * area */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    io___6.ciunit = *lunit;
    s_rdue(&io___6);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    currenp_1.ncur = ibuf[0];
    currenp_1.nctyp = ibuf[1];
    currenp_1.pkc = *pk;
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___9.ciunit = *lunit;
	io___9.cirec = i__ + 1;
	s_rdue(&io___9);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
	    currenp_1.posc[j + i__ * 3 - 4] = frec[j - 1];
	    i__2 = j + i__ * 3 - 4;
	    i__3 = j - 1;
	    currenj_1.curja[i__2].r = curj[i__3].r, currenj_1.curja[i__2].i = 
		    curj[i__3].i;
/* L1: */
	    i__2 = j + i__ * 3 - 4;
	    i__3 = j - 1;
	    currenm_1.curma[i__2].r = curm[i__3].r, currenm_1.curma[i__2].i = 
		    curm[i__3].i;
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* curcom_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


