/* CURSUM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int cursum_(power, phase, lunit)
real *power, *phase;
integer *lunit;
{
    /* Initialized data */

    static real tr = (float).01745329;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    real r__1, r__2, r__3;
    complex q__1, q__2;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    double sqrt(), cos(), sin();
    integer s_rdue(), do_uio(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static integer i__, j;
    static complex cv;
#define pk (equiv_0 + 2)
    static integer nn;

    /* Fortran I/O blocks */
    static cilist io___8 = { 0, 0, 0, 0, 1 };
    static cilist io___11 = { 0, 0, 0, 0, 0 };



/*  Sums currents from file into CURRENT common */

/*  POWER    Power in mode (watts) - Power in all modes should sum to 1 */
/*  PHASE    Phase of mode (degrees) */
/*  LUNIT    Logical unit of random access file (open file) */

/*  File:  76 Bytes record */

/*  Record 1 */

/*  Number of records */
/*  Types of currents available: 0 both, 1 electric only, 2 magnetic only 
*/
/*  Propagation constant (1./meters) */

/*  Record 2 - NCUR+1 */

/*  Position(3)   meters */
/*  Area          meters**2 */
/*  Normal(3)     Unit normal to patch */
/*  J(3)          Electric current * area */
/*  M(3)          Magnetic current * area */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

    r__1 = sqrt(*power);
    r__2 = cos(*phase * tr);
    r__3 = sin(*phase * tr);
    q__2.r = r__2, q__2.i = r__3;
    q__1.r = r__1 * q__2.r, q__1.i = r__1 * q__2.i;
    cv.r = q__1.r, cv.i = q__1.i;
    io___8.ciunit = *lunit;
    s_rdue(&io___8);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    currenp_1.ncur = ibuf[0];
    if (ibuf[1] == 0 || currenp_1.nctyp == 0) {
	currenp_1.nctyp = (float)0.;
    } else {
	if (ibuf[1] == 1 && currenp_1.nctyp == 2) {
	    currenp_1.nctyp = 0;
	}
	if (ibuf[1] == 2 && currenp_1.nctyp == 1) {
	    currenp_1.nctyp = 0;
	}
    }
    currenp_1.pkc = *pk;
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___11.ciunit = *lunit;
	io___11.cirec = i__ + 1;
	s_rdue(&io___11);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
	    i__2 = j + i__ * 3 - 4;
	    i__3 = j - 1;
	    q__2.r = curj[i__3].r * cv.r - curj[i__3].i * cv.i, q__2.i = curj[
		    i__3].r * cv.i + curj[i__3].i * cv.r;
	    i__4 = j + i__ * 3 - 4;
	    q__1.r = q__2.r + currenj_1.curja[i__4].r, q__1.i = q__2.i + 
		    currenj_1.curja[i__4].i;
	    currenj_1.curja[i__2].r = q__1.r, currenj_1.curja[i__2].i = 
		    q__1.i;
/* L1: */
	    i__2 = j + i__ * 3 - 4;
	    i__3 = j - 1;
	    q__2.r = curm[i__3].r * cv.r - curm[i__3].i * cv.i, q__2.i = curm[
		    i__3].r * cv.i + curm[i__3].i * cv.r;
	    i__4 = j + i__ * 3 - 4;
	    q__1.r = q__2.r + currenm_1.curma[i__4].r, q__1.i = q__2.i + 
		    currenm_1.curma[i__4].i;
	    currenm_1.curma[i__2].r = q__1.r, currenm_1.curma[i__2].i = 
		    q__1.i;
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cursum_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


