/* EULER.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__3 = 3;

/* Subroutine */ int euler_(ea, ia, as)
real *ea;
integer *ia;
real *as;
{
    extern /* Subroutine */ int axrta_();
    static real aw[9]	/* was [3][3] */, bw[9]	/* was [3][3] */;
    extern /* Subroutine */ int mtmult_();


/*  Euler Rotation Matrix */

/*  EA  Array of Euler Angles (radians) Positive gives CCW rotation */
/*      about axis specified by IA */
/*  IA  Array of Axis Designators (1 X-axis, 2 Y-axis, 3 Z-axis) */
/*      For example, rotation about Z axis, New Y axis, New Z axis */
/*      would require IA to be: 3,2,3 */

/*  AS  (3,3) Matrix of rotation */

    /* Parameter adjustments */
    as -= 4;
    --ia;
    --ea;

    /* Function Body */
    axrta_(&ea[1], &ia[1], &as[4]);
    axrta_(&ea[2], &ia[2], bw);
    mtmult_(bw, &as[4], aw, &c__3, &c__3, &c__3);
    axrta_(&ea[3], &ia[3], bw);
    mtmult_(bw, aw, &as[4], &c__3, &c__3, &c__3);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* euler_ */

