/* GEOROT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__3 = 3;

/* Subroutine */ int georot_(lunit, rot, cent, transl)
integer *lunit;
real *rot, *cent, *transl;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();

    /* Local variables */
    static real frec[19];
    static integer ibuf[19], j, k;
    static real xa[3], xc[3];
    static integer nn;
    static real un[3];
    extern /* Subroutine */ int mtmult_();

    /* Fortran I/O blocks */
    static cilist io___1 = { 0, 0, 0, 0, 1 };
    static cilist io___5 = { 0, 0, 0, 0, 0 };
    static cilist io___11 = { 0, 0, 0, 0, 0 };



/*  Rotation of Geometry in File about point in space */

/*  LUNIT      Logical unit of currents and geometry file */
/*  ROT(3,3)   Rotation matrix */
/*  CENT(3)    Center of rotation */
/*  TRANSL(3)  Translation after rotation */

    /* Parameter adjustments */
    --transl;
    --cent;
    rot -= 4;

    /* Function Body */
    io___1.ciunit = *lunit;
    s_rdue(&io___1);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
/*  ---------- Loop on points */
    i__1 = ibuf[0];
    for (k = 1; k <= i__1; ++k) {
	io___5.ciunit = *lunit;
	io___5.cirec = k + 1;
	s_rdue(&io___5);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
/*  ---------- Point relative to center of rotation */
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    xc[j - 1] = frec[j - 1] - cent[j];
	}
/*  ---------- Rotate position */
	mtmult_(xc, &rot[4], xa, &c__1, &c__3, &c__3);
/*  ---------- Rotate unit vector */
	mtmult_(&frec[4], &rot[4], un, &c__1, &c__3, &c__3);
	for (j = 1; j <= 3; ++j) {
	    frec[j - 1] = xa[j - 1] + cent[j] + transl[j];
/* L2: */
	    frec[j + 3] = un[j - 1];
	}
/* L3: */
	io___11.ciunit = *lunit;
	io___11.cirec = k + 1;
	s_wdue(&io___11);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* georot_ */

