/* nfpati.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[18000]	/* was [3][6000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[18000]	/* was [3][6000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[18000]	/* was [3][6000] */;
} currenm_;

#define currenm_1 currenm_

struct {
    complex ers;
    real ths, urs;
    integer item;
} dielect_;

#define dielect_1 dielect_

/* Table of constant values */

static real c_b5 = (float)1.;
static real c_b6 = (float)-1.;

/* Subroutine */ int nfpati_(xc, xf, efield, hfield)
real *xc, *xf;
complex *efield, *hfield;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;
    static real eps = (float).008854185;
    static real pn[3] = { (float)0.,(float)0.,(float)1. };
    static real zs = (float)376.73;

    /* System generated locals */
    integer i__1, i__2, i__3, i__4, i__5;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10, 
	    q__11;

    /* Builtin functions */
    double sqrt();
    void c_sqrt(), c_div(), c_sin(), c_cos();

    /* Local variables */
    static complex conj, conm, curj[3], curm[3], zmte, zste, zmtm, zstm;
    static integer i__, j;
    static complex efiel[3], hfiel[3];
    extern /* Subroutine */ int grejc_(), grhjc_(), vlinc_(), cross_();
    static complex ef[3], hf[3];
    static real xb[3], ui[3], xs[3];
    extern /* Subroutine */ int cmtmul_();
    static complex gej[9]	/* was [3][3] */, ghj[9]	/* was [3][3] 
	    */, ein;
    static real xbb[3];
    static complex hin, gte;
    static real xbl;
    extern doublereal dot_();
    static complex gtm;
    static real zte;
    static complex pzm;
    static real ztm;


/*  Near field pattern from currents in common for image in gr.pl. */
/*  with dielectric slab to top surface at Z = 0 */

/*  XC(3)     Position of center of currents */
/*  XF(3)     Field point (meters) */
/*  EFIELD    Electric field (V/m) */
/*  HFIELD    Magnetic field */


/*  Dielectric slab common: /DIELECT/ */
/*  ERS	  Dielectric constant (complex) */
/* 	  ER*cmplx(1.,-(loss tangent)) or */
/* 	  cmplx(ER,-(conductivity(S/m))/(2*pi*8.854185e-12*frequency)) */
/*  THS	  Thickness (m) */
/*  URS	  Relative permeability */
/*  ITEM   If 1, use TEM approximation. 0, infinite slab, -1 actual */

    /* Parameter adjustments */
    --hfield;
    --efield;
    --xf;
    --xc;

    /* Function Body */
/* ------------- -j*2*Pi*Frequency*Mu  ------ electric field factor */
    r__1 = -currenp_1.pkc * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
/* ------------- -j*2*Pi*Frequency*epsilon -- magnetic field factor */
    r__1 = -currenp_1.pkc * cc * eps;
    q__1.r = (float)0., q__1.i = r__1;
    conm.r = q__1.r, conm.i = q__1.i;
    for (i__ = 1; i__ <= 3; ++i__) {
	i__1 = i__;
	efield[i__1].r = (float)0., efield[i__1].i = (float)0.;
/* L1: */
	i__1 = i__;
	hfield[i__1].r = (float)0., hfield[i__1].i = (float)0.;
    }
/* --------- Loop on current patches */
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    i__2 = j - 1;
	    efiel[i__2].r = (float)0., efiel[i__2].i = (float)0.;
	    i__2 = j - 1;
	    hfiel[i__2].r = (float)0., hfiel[i__2].i = (float)0.;
	    xs[j - 1] = currenp_1.posc[j + i__ * 3 - 4] + xc[j];
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curj[i__2].r = currenj_1.curja[i__3].r, curj[i__2].i = 
		    currenj_1.curja[i__3].i;
/* L2: */
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curm[i__2].r = currenm_1.curma[i__3].r, curm[i__2].i = 
		    currenm_1.curma[i__3].i;
	}
	xs[2] = -xs[2];
/* --------- Vector from image to field point */
	vlinc_(&c_b5, &xf[1], &c_b6, xs, xb);
	xbl = sqrt(dot_(xb, xb));
	for (j = 1; j <= 3; ++j) {
/* L6: */
	    ui[j - 1] = xb[j - 1] / xbl;
	}
/* --------- Plane of incidence normal: PN plane normal, UI Reflection
 */
	cross_(pn, ui, xb);
	xbl = sqrt(dot_(xb, xb));
	for (j = 1; j <= 3; ++j) {
/* L7: */
	    xb[j - 1] /= xbl;
	}
	grejc_(&xf[1], xs, &currenp_1.pkc, gej);
	grhjc_(&xf[1], xs, &currenp_1.pkc, ghj);
	if (currenp_1.nctyp < 2) {
/* --------- Electric currents available */
	    cmtmul_(gej, curj, ef);
	    cmtmul_(ghj, curj, hf);
	    for (j = 1; j <= 3; ++j) {
		i__2 = j - 1;
		i__3 = j - 1;
		i__4 = j - 1;
		q__1.r = hfiel[i__3].r + hf[i__4].r, q__1.i = hfiel[i__3].i + 
			hf[i__4].i;
		hfiel[i__2].r = q__1.r, hfiel[i__2].i = q__1.i;
/* L3: */
		i__2 = j - 1;
		i__3 = j - 1;
		i__4 = j - 1;
		q__2.r = ef[i__4].r * conj.r - ef[i__4].i * conj.i, q__2.i = 
			ef[i__4].r * conj.i + ef[i__4].i * conj.r;
		q__1.r = efiel[i__3].r + q__2.r, q__1.i = efiel[i__3].i + 
			q__2.i;
		efiel[i__2].r = q__1.r, efiel[i__2].i = q__1.i;
	    }
	}
	if (currenp_1.nctyp != 1) {
/* --------- Magnetic currents available */
	    cmtmul_(gej, curm, hf);
	    cmtmul_(ghj, curm, ef);
	    for (j = 1; j <= 3; ++j) {
		i__2 = j - 1;
		i__3 = j - 1;
		i__4 = j - 1;
		q__1.r = efiel[i__3].r - ef[i__4].r, q__1.i = efiel[i__3].i - 
			ef[i__4].i;
		efiel[i__2].r = q__1.r, efiel[i__2].i = q__1.i;
/* L4: */
		i__2 = j - 1;
		i__3 = j - 1;
		i__4 = j - 1;
		q__2.r = hf[i__4].r * conm.r - hf[i__4].i * conm.i, q__2.i = 
			hf[i__4].r * conm.i + hf[i__4].i * conm.r;
		q__1.r = hfiel[i__3].r + q__2.r, q__1.i = hfiel[i__3].i + 
			q__2.i;
		hfiel[i__2].r = q__1.r, hfiel[i__2].i = q__1.i;
	    }
	}
	hin.r = (float)0., hin.i = (float)0.;
	ein.r = (float)0., ein.i = (float)0.;
/* --------- Project Electric & magnetic fields on plane of incidence 
*/
	for (j = 1; j <= 3; ++j) {
	    i__2 = j - 1;
	    i__3 = j - 1;
	    q__2.r = xb[i__3] * hfiel[i__2].r, q__2.i = xb[i__3] * hfiel[i__2]
		    .i;
	    q__1.r = hin.r + q__2.r, q__1.i = hin.i + q__2.i;
	    hin.r = q__1.r, hin.i = q__1.i;
/* L8: */
	    i__2 = j - 1;
	    i__3 = j - 1;
	    q__2.r = xb[i__3] * efiel[i__2].r, q__2.i = xb[i__3] * efiel[i__2]
		    .i;
	    q__1.r = ein.r + q__2.r, q__1.i = ein.i + q__2.i;
	    ein.r = q__1.r, ein.i = q__1.i;
	}
/* --------- Incident wave impedances */
	ztm = zs * ui[2];
	zte = zs / ui[2];
	q__5.r = dielect_1.urs * dielect_1.ers.r, q__5.i = dielect_1.urs * 
		dielect_1.ers.i;
	q__4.r = q__5.r - (float)1., q__4.i = q__5.i;
/* Computing 2nd power */
	r__2 = ui[2];
	r__1 = r__2 * r__2;
	q__3.r = q__4.r + r__1, q__3.i = q__4.i;
	c_sqrt(&q__2, &q__3);
	q__1.r = currenp_1.pkc * q__2.r, q__1.i = currenp_1.pkc * q__2.i;
	pzm.r = q__1.r, pzm.i = q__1.i;
	q__3.r = zs * pzm.r, q__3.i = zs * pzm.i;
	q__2.r = q__3.r / currenp_1.pkc, q__2.i = q__3.i / currenp_1.pkc;
	c_div(&q__1, &q__2, &dielect_1.ers);
	zmtm.r = q__1.r, zmtm.i = q__1.i;
	r__1 = zs * currenp_1.pkc * dielect_1.urs;
	q__2.r = r__1, q__2.i = (float)0.;
	c_div(&q__1, &q__2, &pzm);
	zmte.r = q__1.r, zmte.i = q__1.i;
	if (dielect_1.item == 1) {
	    r__1 = currenp_1.pkc * dielect_1.ths;
	    c_sqrt(&q__7, &dielect_1.ers);
	    q__6.r = r__1 * q__7.r, q__6.i = r__1 * q__7.i;
	    c_sin(&q__5, &q__6);
	    q__4.r = zs * q__5.r, q__4.i = zs * q__5.i;
	    r__2 = currenp_1.pkc * dielect_1.ths;
	    c_sqrt(&q__10, &dielect_1.ers);
	    q__9.r = r__2 * q__10.r, q__9.i = r__2 * q__10.i;
	    c_cos(&q__8, &q__9);
	    c_div(&q__3, &q__4, &q__8);
	    q__2.r = q__3.r * (float)0. - q__3.i * (float)-1., q__2.i = 
		    q__3.r * (float)-1. + q__3.i * (float)0.;
	    c_sqrt(&q__11, &dielect_1.ers);
	    c_div(&q__1, &q__2, &q__11);
	    zstm.r = q__1.r, zstm.i = q__1.i;
	    zste.r = zstm.r, zste.i = zstm.i;
	} else if (dielect_1.item == -1) {
	    q__5.r = dielect_1.ths * pzm.r, q__5.i = dielect_1.ths * pzm.i;
	    c_sin(&q__4, &q__5);
	    q__3.r = zmtm.r * q__4.r - zmtm.i * q__4.i, q__3.i = zmtm.r * 
		    q__4.i + zmtm.i * q__4.r;
	    q__7.r = dielect_1.ths * pzm.r, q__7.i = dielect_1.ths * pzm.i;
	    c_cos(&q__6, &q__7);
	    c_div(&q__2, &q__3, &q__6);
	    q__1.r = q__2.r * (float)0. - q__2.i * (float)-1., q__1.i = 
		    q__2.r * (float)-1. + q__2.i * (float)0.;
	    zstm.r = q__1.r, zstm.i = q__1.i;
	    q__5.r = dielect_1.ths * pzm.r, q__5.i = dielect_1.ths * pzm.i;
	    c_sin(&q__4, &q__5);
	    q__3.r = zmte.r * q__4.r - zmte.i * q__4.i, q__3.i = zmte.r * 
		    q__4.i + zmte.i * q__4.r;
	    q__7.r = dielect_1.ths * pzm.r, q__7.i = dielect_1.ths * pzm.i;
	    c_cos(&q__6, &q__7);
	    c_div(&q__2, &q__3, &q__6);
	    q__1.r = q__2.r * (float)0. - q__2.i * (float)-1., q__1.i = 
		    q__2.r * (float)-1. + q__2.i * (float)0.;
	    zste.r = q__1.r, zste.i = q__1.i;
	} else if (dielect_1.item == 0) {
	    zstm.r = zmtm.r, zstm.i = zmtm.i;
	    zste.r = zmte.r, zste.i = zmte.i;
	}
/* --------- Find the reflection coefficients of two polarizations */
	q__2.r = ztm - zstm.r, q__2.i = -zstm.i;
	q__3.r = ztm + zstm.r, q__3.i = zstm.i;
	c_div(&q__1, &q__2, &q__3);
	gtm.r = q__1.r, gtm.i = q__1.i;
	q__2.r = zste.r - zte, q__2.i = zste.i;
	q__3.r = zste.r + zte, q__3.i = zste.i;
	c_div(&q__1, &q__2, &q__3);
	gte.r = q__1.r, gte.i = q__1.i;
/* --------- Reduce reflected fields */
	q__1.r = hin.r * gtm.r - hin.i * gtm.i, q__1.i = hin.r * gtm.i + 
		hin.i * gtm.r;
	hin.r = q__1.r, hin.i = q__1.i;
	q__1.r = ein.r * gte.r - ein.i * gte.i, q__1.i = ein.r * gte.i + 
		ein.i * gte.r;
	ein.r = q__1.r, ein.i = q__1.i;
/* --------- Find reflected wave orthogonal polarization direction */
	cross_(ui, xb, xbb);
/* --------- Find total fields from projection on output polarizations
 */
	for (j = 1; j <= 3; ++j) {
	    i__2 = j;
	    i__3 = j;
	    i__4 = j - 1;
	    q__3.r = xb[i__4] * ein.r, q__3.i = xb[i__4] * ein.i;
	    q__2.r = efield[i__3].r + q__3.r, q__2.i = efield[i__3].i + 
		    q__3.i;
	    i__5 = j - 1;
	    q__5.r = xbb[i__5] * hin.r, q__5.i = xbb[i__5] * hin.i;
	    q__4.r = zs * q__5.r, q__4.i = zs * q__5.i;
	    q__1.r = q__2.r + q__4.r, q__1.i = q__2.i + q__4.i;
	    efield[i__2].r = q__1.r, efield[i__2].i = q__1.i;
/* L9: */
	    i__2 = j;
	    i__3 = j;
	    i__4 = j - 1;
	    q__3.r = xb[i__4] * hin.r, q__3.i = xb[i__4] * hin.i;
	    q__2.r = hfield[i__3].r + q__3.r, q__2.i = hfield[i__3].i + 
		    q__3.i;
	    i__5 = j - 1;
	    q__5.r = xbb[i__5] * ein.r, q__5.i = xbb[i__5] * ein.i;
	    q__4.r = q__5.r / zs, q__4.i = q__5.i / zs;
	    q__1.r = q__2.r - q__4.r, q__1.i = q__2.i - q__4.i;
	    hfield[i__2].r = q__1.r, hfield[i__2].i = q__1.i;
	}
/* L5: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* nfpati_ */

