/* PATBEAM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b2 = 10.;

doublereal patbeam_(bl, bn, nappr)
real *bl, *bn;
integer *nappr;
{
    /* Initialized data */

    static real tr = (float).01745329;

    /* System generated locals */
    real ret_val;
    doublereal d__1;

    /* Builtin functions */
    double pow_dd(), acos();


/*  Pattern Approximation  I: E = cos(Theta/2)**N  Beamwidth (degrees) */
/*                        II: E = cos(Theta)**N */

/*  BL      Beamwidth level dB */
/*  BN      Pattern exponent */
/*  NAPPR   Approximation number */

    d__1 = (doublereal) (-dabs(*bl) / (*bn * (float)20.));
    ret_val = acos(pow_dd(&c_b2, &d__1)) * (float)4. / *nappr / tr;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* patbeam_ */

