/* PATEXP.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal patexp_(bw, bl, nappr)
real *bw, *bl;
integer *nappr;
{
    /* Initialized data */

    static real tr = (float).01745329;

    /* System generated locals */
    real ret_val;

    /* Builtin functions */
    double cos(), r_lg10();

    /* Local variables */
    static real cca;


/*  Pattern Approximation  I: E = cos(Theta/2)**N Pattern Exponent */
/*                        II: E = cos(Theta)**N   Pattern Exponent */

/*  BWE     Beamwidth  (degrees) */
/*  BLE     Beamwidth level (dB) */
/*  NAPPR   Approximation number */

    cca = cos(*bw * tr * (float).25 * *nappr);
    if (cca < (float)0.) {
/* --------------- Impossible beamwidth */
	ret_val = (float)0.;
    } else {
	ret_val = -dabs(*bl) / (r_lg10(&cca) * (float)20.);
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* patexp_ */

