/* patind.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__3 = 3;
static integer c__1 = 1;
static integer c__4 = 4;
static doublereal c_b26 = 10.;
static real c_b30 = (float)360.;
static real c_b31 = (float)180.;
static real c_b34 = (float)1.;

/* Subroutine */ int patind_(inst, theta, phi, et, ep)
integer *inst;
real *theta, *phi;
complex *et, *ep;
{
    /* Initialized data */

    static real tr = (float).01745329;
    static real gcons = (float).1826374;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3, r__4;
    doublereal d__1;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8;

    /* Builtin functions */
    integer s_rsle(), do_lio(), e_rsle();
    double pow_dd(), cos(), sin(), r_mod(), r_sign();

    /* Local variables */
    static complex patp[16380], patt[16380];
    static integer i__, j, n;
    static real t, u;
    static complex x[4], y[4];
    extern /* Subroutine */ int arads_();
    static integer nscan, itype;
    extern /* Subroutine */ int retsp_();
    static integer nm, nn, np, nt;
    static real sp[3], sr[3], vp, vt;
    static integer npoint;
    static real dsc, amp, phh, amt, thh, scp, php, scs, dst, pht, tin, sgn, 
	    stp, sts;

    /* Fortran I/O blocks */
    static cilist io___3 = { 0, 31, 0, 0, 0 };
    static cilist io___7 = { 0, 31, 0, 0, 0 };
    static cilist io___14 = { 0, 31, 0, 0, 0 };



/*  Interpolation from multiple patterns */
/*  using bilinear interpolation */

/*  INST    - 1 Initialize: */
/*            2 Return pattern value */
/*  THETA       Pattern Angle (deg) (Value to add to bias to gain */
/*              on initialization dB) */
/*  PHI         Pattern Angle (deg) (Value to add to bias to gain */
/*              on initialization dB) */
/*  ET          Complex electric field V/m @ 1 m, 1 w input Theta */
/*  EP          Complex electric field V/m @ 1 m, 1 w input Phi */

    if (*inst < 2) {

/*  Reads ASCII data file LU = 31, open before calling */

/* ------- Initialize */
/*  1st record: */
/*  Type: [1 Conic, 2 Great Circle], # Scans, # Points in scan */
/*  Type = -2 if Theta > 180 or Theta < 0 included */

/*  2nd record:  Step angles: Start, Step; Scan angles: Start, Step */
/*  3rd record & following: (Theta) Ampl. dB, Phase, (Phi) Ampl. Phase
 */

	s_rsle(&io___3);
	do_lio(&c__3, &c__1, (char *)&itype, (ftnlen)sizeof(integer));
	do_lio(&c__3, &c__1, (char *)&nscan, (ftnlen)sizeof(integer));
	do_lio(&c__3, &c__1, (char *)&npoint, (ftnlen)sizeof(integer));
	e_rsle();
	s_rsle(&io___7);
	do_lio(&c__4, &c__1, (char *)&sts, (ftnlen)sizeof(real));
	do_lio(&c__4, &c__1, (char *)&stp, (ftnlen)sizeof(real));
	do_lio(&c__4, &c__1, (char *)&scs, (ftnlen)sizeof(real));
	do_lio(&c__4, &c__1, (char *)&scp, (ftnlen)sizeof(real));
	e_rsle();
	i__1 = nscan;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    i__2 = npoint;
	    for (j = 1; j <= i__2; ++j) {
		s_rsle(&io___14);
		do_lio(&c__4, &c__1, (char *)&amt, (ftnlen)sizeof(real));
		do_lio(&c__4, &c__1, (char *)&pht, (ftnlen)sizeof(real));
		do_lio(&c__4, &c__1, (char *)&amp, (ftnlen)sizeof(real));
		do_lio(&c__4, &c__1, (char *)&php, (ftnlen)sizeof(real));
		e_rsle();
		n = (i__ - 1) * npoint + j;
		i__3 = n - 1;
		d__1 = (doublereal) ((amt + *theta) / (float)20.);
		r__1 = pow_dd(&c_b26, &d__1);
		r__2 = cos(pht * tr);
		r__3 = sin(pht * tr);
		q__3.r = r__2, q__3.i = r__3;
		q__2.r = r__1 * q__3.r, q__2.i = r__1 * q__3.i;
		q__1.r = q__2.r / gcons, q__1.i = q__2.i / gcons;
		patt[i__3].r = q__1.r, patt[i__3].i = q__1.i;
/* L1: */
		i__3 = n - 1;
		d__1 = (doublereal) ((amp + *theta) / (float)20.);
		r__1 = pow_dd(&c_b26, &d__1);
		r__2 = cos(php * tr);
		r__3 = sin(php * tr);
		q__3.r = r__2, q__3.i = r__3;
		q__2.r = r__1 * q__3.r, q__2.i = r__1 * q__3.i;
		q__1.r = q__2.r / gcons, q__1.i = q__2.i / gcons;
		patp[i__3].r = q__1.r, patp[i__3].i = q__1.i;
	    }
/* L2: */
	}
	d__1 = (doublereal) (*theta / (float)20.);
	vt = pow_dd(&c_b26, &d__1) / gcons;
	d__1 = (doublereal) (*phi / (float)20.);
	vp = pow_dd(&c_b26, &d__1) / gcons;
    } else {
/* -------- Return value */
	sp[0] = (float)1.;
	sp[1] = tr * *theta;
	sp[2] = tr * *phi;
/* -------- Convert to rectangular and back to spherical */
	arads_(sp, sr);
	retsp_(sr, sp);
	if (itype == 1) {
/* -------- Conical patterns */
	    thh = sp[1] / tr;
	    phh = sp[2] / tr;
	} else {
/* -------- Great circle patterns */
	    thh = sp[2] / tr;
	    phh = sp[1] / tr;
	    if (thh < (float)0. && itype == -2) {
		phh = (float)360. - phh;
		thh += (float)180.;
	    }
	}
	if (itype != 2) {
	    nm = (float)360. / scp + (float).1;
	}
	if (itype == 2) {
	    nm = (float)180. / scp + (float).1;
	}
	dsc = phh - scs;
	if (itype != 2) {
	    dsc = r_mod(&dsc, &c_b30);
	}
	if (itype == 2 && (r__1 = dsc - (float)180., dabs(r__1)) > (float).02)
		 {
	    dsc = r_mod(&dsc, &c_b31);
	}
	dsc /= scp;
	if (dsc < (float)0.) {
	    dsc += nm;
	}
	np = dsc;
	t = dsc - np;
	++np;
	if (np == nm) {
	    --np;
	    t += 1;
	}
	if (itype == 2) {
	    nm = (float)360. / stp + (float).1;
	}
	if (itype != 2) {
	    nm = (float)180. / stp + (float).1;
	}
	dst = thh - sts;
	if (itype == 2) {
	    dst = r_mod(&dst, &c_b30);
	}
	if (itype != 2 && (r__1 = dst - (float)180., dabs(r__1)) > (float).02)
		 {
	    dst = r_mod(&dst, &c_b31);
	}
	dst /= stp;
	if (dst < (float)0.) {
	    dst += nm;
	}
	nt = dst;
	u = dst - nt;
	++nt;
	if (itype == 1) {
	    tin = sts + (nt - 1) * stp;
	}
	if (abs(itype) == 2) {
	    tin = scs + (np - 1) * scp;
	}
	r__1 = sin(tin * tr);
	sgn = r_sign(&c_b34, &r__1);
	for (i__ = 1; i__ <= 4; ++i__) {
	    i__1 = i__ - 1;
	    y[i__1].r = (float)0., y[i__1].i = (float)0.;
/* L3: */
	    i__1 = i__ - 1;
	    x[i__1].r = (float)0., x[i__1].i = (float)0.;
	}
/* -------- Pick points for bilinear interpolation */
	if (np <= npoint && nt - 1 <= nscan) {
	    nn = np + (nt - 1) * npoint + 2;
	    i__1 = nn - 1;
	    y[0].r = patt[i__1].r, y[0].i = patt[i__1].i;
	    i__1 = nn - 1;
	    x[0].r = patp[i__1].r, x[0].i = patp[i__1].i;
	    if (np + 1 <= npoint && nt - 1 <= nscan) {
		nn = np + 1 + (nt - 1) * npoint + 2;
		i__1 = nn - 1;
		y[1].r = patt[i__1].r, y[1].i = patt[i__1].i;
		i__1 = nn - 1;
		x[1].r = patp[i__1].r, x[1].i = patp[i__1].i;
	    }
	}
	if (np + 1 <= npoint && nt < nscan) {
	    nn = np + nt * npoint + 2;
	    i__1 = nn - 1;
	    y[3].r = patt[i__1].r, y[3].i = patt[i__1].i;
	    i__1 = nn - 1;
	    x[3].r = patp[i__1].r, x[3].i = patp[i__1].i;
	    if (np + 1 <= npoint && nt < nscan) {
		nn = np + 1 + nt * npoint + 2;
		i__1 = nn - 1;
		y[2].r = patt[i__1].r, y[2].i = patt[i__1].i;
		i__1 = nn - 1;
		x[2].r = patp[i__1].r, x[2].i = patp[i__1].i;
	    }
	}
	r__1 = ((float)1. - t) * ((float)1. - u);
	q__5.r = r__1 * y[0].r, q__5.i = r__1 * y[0].i;
	r__2 = t * ((float)1. - u);
	q__6.r = r__2 * y[1].r, q__6.i = r__2 * y[1].i;
	q__4.r = q__5.r + q__6.r, q__4.i = q__5.i + q__6.i;
	r__3 = t * u;
	q__7.r = r__3 * y[2].r, q__7.i = r__3 * y[2].i;
	q__3.r = q__4.r + q__7.r, q__3.i = q__4.i + q__7.i;
	r__4 = ((float)1. - t) * u;
	q__8.r = r__4 * y[3].r, q__8.i = r__4 * y[3].i;
	q__2.r = q__3.r + q__8.r, q__2.i = q__3.i + q__8.i;
	q__1.r = vt * q__2.r, q__1.i = vt * q__2.i;
	et->r = q__1.r, et->i = q__1.i;
	r__1 = ((float)1. - t) * ((float)1. - u);
	q__5.r = r__1 * x[0].r, q__5.i = r__1 * x[0].i;
	r__2 = t * ((float)1. - u);
	q__6.r = r__2 * x[1].r, q__6.i = r__2 * x[1].i;
	q__4.r = q__5.r + q__6.r, q__4.i = q__5.i + q__6.i;
	r__3 = t * u;
	q__7.r = r__3 * x[2].r, q__7.i = r__3 * x[2].i;
	q__3.r = q__4.r + q__7.r, q__3.i = q__4.i + q__7.i;
	r__4 = ((float)1. - t) * u;
	q__8.r = r__4 * x[3].r, q__8.i = r__4 * x[3].i;
	q__2.r = q__3.r + q__8.r, q__2.i = q__3.i + q__8.i;
	q__1.r = vp * q__2.r, q__1.i = vp * q__2.i;
	ep->r = q__1.r, ep->i = q__1.i;
	q__1.r = sgn * et->r, q__1.i = sgn * et->i;
	et->r = q__1.r, et->i = q__1.i;
	q__1.r = sgn * ep->r, q__1.i = sgn * ep->i;
	ep->r = q__1.r, ep->i = q__1.i;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* patind_ */

