/* PATROT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__3 = 3;
static integer c__1 = 1;

/* Subroutine */ int patrot_(rot, vr, vt, vp, theta, phi, vtp, vpp)
real *rot, *vr, *vt, *vp, *theta, *phi, *vtp, *vpp;
{
    extern /* Subroutine */ int retsp_();
    static real sp[3], xx[3];
    extern /* Subroutine */ int mtmult_();


/*  Rotates Pattern direction in prime coordinates to rotated */
/*  antenna coordinates */

/*  ROT(3,3)   Rotation matrix */
/*  VR(3)      Pattern direction unit vector */
/*  VT(3)      Theta unit vector for VR direction */
/*  VP(3)      Phi unit vector for VR direction */

/*  THETA      Pattern direction in rotated antenna coordinates */
/*  PHI        Pattern direction in rotated antenna (radians) */
/*  VTP(3)     Direction of Theta component in rotated coordinates */
/*  VPP(3)     Direction of  Phi  component in rotated coordinates */

    /* Parameter adjustments */
    --vpp;
    --vtp;
    --vp;
    --vt;
    --vr;
    rot -= 4;

    /* Function Body */
    mtmult_(&rot[4], &vr[1], xx, &c__3, &c__3, &c__1);
    retsp_(xx, sp);
    *theta = sp[1];
    *phi = sp[2];
    mtmult_(&rot[4], &vt[1], &vtp[1], &c__3, &c__3, &c__1);
    mtmult_(&rot[4], &vp[1], &vpp[1], &c__3, &c__3, &c__1);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* patrot_ */

