/* SPACUR.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int spacur_(width, freq, pol, npts, lunit)
real *width, *freq, *pol;
integer *npts, *lunit;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1, i__2, i__3;
    complex q__1, q__2;
    static real equiv_0[19];
    static complex equiv_1[10];

    /* Builtin functions */
    double sqrt();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
#define frec ((real *)equiv_1)
    static integer krec;
#define ibuf ((integer *)equiv_0)
#define curm ((complex *)((integer *)equiv_1 + 13))
    static integer i__, j, k;
    static real w, wavel;
    static complex am[3];
    static real hp;
#define pk (equiv_0 + 2)
    static integer nn;
    extern doublereal rradcn_();
    extern /* Subroutine */ int rpperm_();
    static real amm, pos;

    /* Fortran I/O blocks */
    static cilist io___11 = { 0, 0, 0, 0, 1 };
    static cilist io___19 = { 0, 0, 0, 0, 0 };



/*  Current file of square microstrip patch */

/*  WIDTH     Effective width of patch (m) */
/*  FREQ      Frequency (GHz) */
/*  POL       Polarization: 0 linear, -1 RHC, +1 LHC */
/*  NPTS      Number of points in integrals along each edge */
/*  LUNIT     Logical unit of random access file with currents */

    wavel = cc / *freq;
    *pk = pi * (float)2. / wavel;
    w = *width / wavel;
/* --------------- Find maximum magnetic current for 1 w. input */
    amm = sqrt((float)1. / rradcn_(&w)) * (float)2.;
    hp = *width / *npts;
    ibuf[0] = *npts << 2;
    ibuf[1] = 2;
    io___11.ciunit = *lunit;
    s_wdue(&io___11);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    krec = 1;
/* --------------- Loop on edges; axis: X, Y, -X, -Y */
    for (j = 1; j <= 4; ++j) {
	i__1 = *npts;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    pos = hp * (i__ - (float).5);
	    rpperm_(&pos, width, width, frec, am, &j, pol);
	    ++krec;
	    for (k = 1; k <= 3; ++k) {
/* L1: */
		i__2 = k - 1;
		i__3 = k - 1;
		q__2.r = amm * am[i__3].r, q__2.i = amm * am[i__3].i;
		q__1.r = hp * q__2.r, q__1.i = hp * q__2.i;
		curm[i__2].r = q__1.r, curm[i__2].i = q__1.i;
	    }
	    io___19.ciunit = *lunit;
	    io___19.cirec = krec;
	    s_wdue(&io___19);
	    for (nn = 1; nn <= 19; ++nn) {
		do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	    }
	    e_wdue();
/* L2: */
	}
/* L3: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* spacur_ */

#undef pk
#undef curm
#undef ibuf
#undef frec


