/* VSLCMG.F -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int vslcmg_(freq, fd, al, widl, uu, ul, npts, curr, icav, 
	lunit, yin)
real *freq, *fd, *al, *widl, *uu, *ul;
integer *npts;
real *curr;
integer *icav, *lunit;
complex *yin;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.14159265;

    /* System generated locals */
    complex q__1;

    /* Builtin functions */
    double sin(), sqrt();

    /* Local variables */
    extern /* Subroutine */ int curcom_(), vslmuc_(), vslcur_();
    static real alc, fdi[3];


/*  Current multiplier for Vee slot and Input Admittance */

/*  FREQ    Frequency (GHz) */
/*  FD(3)   Feed point (m) */
/*  AL      Length of slot (sum of both arms) (m) */
/*  WIDL    Width of slot */
/*  UU(3)   Direction of unit vector of upper arm */
/*  UL(3)   Direction of unit vector of lower arm */
/*  NPTS    Number of points along each arm */
/*  CURR    Multiplier on current magnitude (for mutual = 1) */
/*  ICAV    0 - Radiates on both sides, 1 Cavity behind */
/*  LUNIT   Logical unit of file for currents */

    /* Parameter adjustments */
    --ul;
    --uu;
    --fd;

    /* Function Body */
/* ------------- Find currents on single slot */
    *curr = (float)1.;
    alc = *al;
    vslcur_(freq, &fd[1], al, &uu[1], &ul[1], npts, curr, lunit);
/* ------------- Load into currents common */
    curcom_(lunit);
    fdi[0] = fd[1];
    fdi[1] = fd[2] + *widl;
    fdi[2] = fd[3];
/* ------------- Find self impedance */
    vslmuc_(fdi, al, &alc, &uu[1], &ul[1], npts, yin);
    *curr = (float)1. / sqrt(yin->r * sin(pi * *al * *freq / cc));
    if (*icav == 1) {
	q__1.r = yin->r / (float)2., q__1.i = yin->i / (float)2.;
	yin->r = q__1.r, yin->i = q__1.i;
	*curr *= (float)2.;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;

/*  Note fewer currents are needed for pattern calculations than for the 
*/
/*  self impedance.  The currents file can be reinitialized VSLCUR with */
/*  fewer points but with CURR from this routine to normalize power to */
/*  1 watt. */

} /* vslcmg_ */

