      SUBROUTINE ATHET(S,AT)
C 
C  Unit Vector in Theta Direction (Rectangular Coordinates) 
C 
C  S - Spherical Coordinates of location
C  AT - Unit Vector 
C 
      DIMENSION S(3),AT(3)
      AT(1)=COS(S(2))*COS(S(3)) 
      AT(2)=COS(S(2))*SIN(S(3)) 
      AT(3)=-SIN(S(2))
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END 
