      SUBROUTINE AXRTA(EA,IA,AS)
C
C  Rotation Matrix for Rectangular Coordinates
C
C  EA  Rotation Angle (radians)
C  IA  Axis of rotation: 1 X-axis, 2 Y-axis, 3 Z-axis
C  AS(3,3)  Rotation Matrix
C
      DIMENSION AS(3,3)
      CA=COS(EA)
      SA=SIN(EA)
      IF(IA.EQ.2)SA=-SA
      DO1I=1,3
      DO2J=I,3
      AS(J,I)=-SA
    2 AS(I,J)=SA
    1 AS(I,I)=CA
      DO3I=1,3
      AS(I,IA)=0.
    3 AS(IA,I)=0.
      AS(IA,IA)=1.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
