      SUBROUTINE CVTROT(CURI,ROT,CURO)
C
C  Rotation of Complex Vector by rotation matrix
C
C  CURI(3)    Input vector
C  ROT(3,3)   Rotation matrix
C  CURO(3)    Output vector
C
      DIMENSION ROT(3,3)
      COMPLEX CURI(3),CURO(3)
      DO 2 I=1,3
      CURO(I)=0.
      DO 1 J=1,3
    1 CURO(I)=CURO(I)+CURI(J)*ROT(J,I)
    2 CONTINUE
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
