      SUBROUTINE FFDIRC(THETA,PHI,VR,VT,VP)
C
C  Far Field direction vectors
C
C  THETA, PHI   Pattern angles (radians)
C  VR(3)        Radius unit vector
C  VT(3)        Theta polarization unit vector
C  VP(3)        Phi polarization unit vector
C
      DIMENSION S(3),VR(3),VT(3),VP(3)
      S(1)=1.
      S(2)=THETA
      S(3)=PHI
      CALL ARADS(S,VR)
      CALL ATHET(S,VT)
      CALL APHI(S,VP)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
