      SUBROUTINE FILROT(LUNIT,ROT,CENT)
C
C  Rotation of Currents in File about point in space
C
C  LUNIT      Logical unit of currents and geometry file
C  ROT(3,3)   Rotation matrix
C  CENT(3)    Center of rotation
C
      DIMENSION ROT(3,3),CENT(3),XC(3),XA(3),FREC(19)
      INTEGER*4 IBUF(19)
      COMPLEX CURJ(3),CURM(3),CURJO(3),CURMO(3)
      EQUIVALENCE (IBUF(3),PK),(FREC(8),CURJ(1)),(FREC(14),CURM(1))
      READ(LUNIT,REC=1)(IBUF(NN),NN=1,19)
      DO 3 K=1,IBUF(1)
      READ(LUNIT,REC=K+1)(FREC(NN),NN=1,19)
C  ------------ Rotate point
      DO 1 J=1,3
    1 XC(J)=FREC(J)-CENT(J)
      CALL MTMULT(XC,ROT,XA,1,3,3)
C  ------------ Rotate currents
      CALL CVTROT(CURJ,ROT,CURJO)
      CALL CVTROT(CURM,ROT,CURMO)
      DO 2 J=1,3
      XC(J)=FREC(J+4)
      FREC(J)=XA(J)+CENT(J)
      CURJ(J)=CURJO(J)
    2 CURM(J)=CURMA(J)
C  ------------ Rotate normal
      CALL MTMULT(XC,ROT,FREC(5),1,3,3)
    3 WRITE(LUNIT,REC=K+1)(FREC(NN),NN=1,19)
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
