      SUBROUTINE PINTS(PL,UL,PP,PN,T,P,NIS)
C
C  Intersection of Unbounded plane and line expressed as point and
C  unit vector
C
C  PL(3)   Input point on line
C  UL(3)   Input unit vector direction of line
C  PP(3)   Input Point on plane
C  PN(3)   Input unit vector normal to plane
C  T       Output distance from point PL to plane
C  P(3)    Output intersection point
C  NIS     Output = -1 if no intersection
C
      DIMENSION PL(3),UL(3),PP(3),PN(3),P(3)
      IF(DOT(PN,UL).NE.0.)THEN
      NIS=1
      T=(DOT(PN,PP)-DOT(PN,PL))/DOT(PN,UL)
      DO1I=1,3
    1 P(I)=PL(I)+T*UL(I)
      ELSE
      NIS=-1
      ENDIF
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
