% MATLAB script file for calculating far-field
% patterns of open-ended waveguide
%
% PART c: currents at open-ended guide
%

V0=2/sqrt(wx*wy/Z0);	% normalized voltage 

Mxp=V0*cos(pi*xsp/wx);	% Nsxp by 1 array, x' mag current density
Mxa=Mxp*Iy;		% Nsxp by Nsyp array, x' mag current  den
Msu=reshape(Mxa,Ns,1)*ut1 ;	% Ns by 3 array, x mag current den
Ms=Msu.*(dS*ones(1,3));		% current in Volt*meter

Jyp=V0/Z0*cos(pi*xsp/wx);% Nsxp by 1, y' elect current density
Jya=Jyp*Iy;		% Nsxp by Nsyp, y' elect current den
Jsu=reshape(Jya,Ns,1)*ut2;% Ns by 3 array, y elect current den
Js=Jsu.*(dS*ones(1,3));	% current in Amp*meter

%