function Fr=po09fun1(kr)

% function m-file for characteristic equation

global om e0 m0 nph Ra Xs

k0=om/11.803e9;
Z0=sqrt(m0/e0);
kz=sqrt(k0^2-kr.^2);	% z wavenumbers
Jn=bessela(nph,kr*Ra); % bessel function, 1st kind, nphi
DJn=-bessela(nph+1,kr*Ra)+nph./kr/Ra.*bessela(nph,kr*Ra);
	% derivative of bessel function, 1st kind, nphi 

Fr=kr./kz.*Ra/nph*om*m0/Z0.*DJn./Jn...
	+Xs.*kz./kr.^2*nph./Ra.*Jn...
	./(Z0*Jn-Xs.*k0./kr.*DJn); % characteristic eq

%