/* ALINP.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

doublereal alinp_(x, xa, ya, np, ni)
real *x, *xa, *ya;
integer *np, *ni;
{
    /* System generated locals */
    integer i__1, i__2;
    real ret_val;

    /* Local variables */
    static integer i__, j, ne;
    static real of;
    static integer nh, nm, no;
    static real xi[5], yi[5];
    static integer ns;
    static real yl;


/*  INTERPOLATION ON TABLE */

/*  XA,YA  ARRAYS WITH NP POINTS, MONOTONIC X */
/*  NI  NUMBER OF POINTS IN INTERPOLATION (LAGRANGE) */

    /* Parameter adjustments */
    --ya;
    --xa;

    /* Function Body */
    no = *ni;
    if (no > 5) {
	no = 5;
    }
    nh = no / 2;
    of = (float)1.;
    if (xa[*np] < xa[1]) {
	of = (float)-1.;
    }
    ns = 0;
    if ((*x - xa[nh]) * of < (float)0.) {
	goto L2;
    }
    ns = *np - *ni;
    ne = *np - nh;
    if ((*x - xa[ne]) * of > (float)0.) {
	goto L2;
    }
    nm = nh + 1;
    i__1 = ne;
    for (i__ = nm; i__ <= i__1; ++i__) {
	ns = i__ - nm;
	if ((*x - xa[i__]) * of < (float)0.) {
	    goto L2;
	}
/* L1: */
    }
L2:
    i__1 = *ni;
    for (i__ = 1; i__ <= i__1; ++i__) {
	j = ns + i__;
	xi[i__ - 1] = xa[j];
/* L3: */
	yi[i__ - 1] = ya[j];
    }

/*  INTERPOLATION */

    ret_val = (float)0.;
    i__1 = *ni;
    for (i__ = 1; i__ <= i__1; ++i__) {
	yl = (float)1.;
	i__2 = *ni;
	for (j = 1; j <= i__2; ++j) {
	    if (i__ == j) {
		goto L5;
	    }
	    yl = yl * (*x - xi[j - 1]) / (xi[i__ - 1] - xi[j - 1]);
L5:
	    ;
	}
/* L4: */
	ret_val += yl * yi[i__ - 1];
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ret_val;
} /* alinp_ */

