/* AXRTA.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int axrta_(ea, ia, as)
real *ea;
integer *ia;
real *as;
{
    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static integer i__, j;
    static real ca, sa;


/*  Rotation Matrix for Rectangular Coordinates */

/*  EA  Rotation Angle (radians) */
/*  IA  Axis of rotation: 1 X-axis, 2 Y-axis, 3 Z-axis */
/*  AS(3,3)  Rotation Matrix */

    /* Parameter adjustments */
    as -= 4;

    /* Function Body */
    ca = cos(*ea);
    sa = sin(*ea);
    if (*ia == 2) {
	sa = -sa;
    }
    for (i__ = 1; i__ <= 3; ++i__) {
	for (j = i__; j <= 3; ++j) {
	    as[j + i__ * 3] = -sa;
/* L2: */
	    as[i__ + j * 3] = sa;
	}
/* L1: */
	as[i__ + i__ * 3] = ca;
    }
    for (i__ = 1; i__ <= 3; ++i__) {
	as[i__ + *ia * 3] = (float)0.;
/* L3: */
	as[*ia + i__ * 3] = (float)0.;
    }
    as[*ia + *ia * 3] = (float)1.;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* axrta_ */

