/* CURCON.F -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;

/* Subroutine */ int curcon_(pkc, vr, hfield, nplts, lunit, iter)
real *pkc, *vr;
complex *hfield;
integer *nplts, *lunit, *iter;
{
    /* Initialized data */

    static real xc[3] = { (float)0.,(float)0.,(float)0. };

    /* System generated locals */
    integer i__1, i__2, i__3;

    /* Local variables */
    static integer i__, k, il, ip;
    extern /* Subroutine */ int curadd_();
    extern /* Subroutine */ int blockn_();
    extern /* Subroutine */ int curcat_(), refpcu_(), refcur_(), curcom_(), 
	    curequ_();
    static real xbb[1];
    static integer ipp, inr, iqq;


/*  Currents convergence for Incident plane wave */

/*  PKC    Propagation constant */
/*  VR(3)  Incident wave direction */
/*  HFIELD Incident wave magnetic field */
/*  NPLTS  Number of plates */
/*  LUNIT  Array of logical units */

    /* Parameter adjustments */
    --lunit;
    --hfield;
    --vr;

    /* Function Body */
/*  -----------  Find initial currents into first files */
    i__1 = *nplts;
    for (ip = 1; ip <= i__1; ++ip) {
	refpcu_(pkc, &vr[1], &hfield[1], blockn_, xbb, &lunit[ip], &c__1);
/*  ----------- Move geometry into third files */
	ipp = ip + (*nplts << 1);
	curequ_(&lunit[ip], &lunit[ipp]);
	ipp = ip + *nplts;
/*  -----------  Move initial currents into second files */
/* L2: */
	curequ_(&lunit[ip], &lunit[ipp]);
    }
/*  -----------  Loop for convergence */
    i__1 = *iter;
    for (inr = 1; inr <= i__1; ++inr) {
/*  ----------- Move all currents into common except plate */
	i__2 = *nplts;
	for (ip = 1; ip <= i__2; ++ip) {
	    k = 1;
	    i__3 = *nplts;
	    for (il = 1; il <= i__3; ++il) {
		if (ip == il) {
		    goto L3;
		}
		ipp = il + *nplts;
		if (k == 1) {
		    curcom_(&lunit[ipp]);
		    k = 2;
		} else {
		    curcat_(&lunit[ipp]);
		}
L3:
		;
	    }
/*  ----------- Find third file currents due to currents in common
 */
	    ipp = ip + (*nplts << 1);
	    refcur_(xc, pkc, blockn_, xbb, &lunit[ipp], &c__0);
/* L4: */
	}
/*  ----------- Sum currents into 1st file */
	i__2 = *nplts;
	for (ip = 1; ip <= i__2; ++ip) {
	    ipp = ip + (*nplts << 1);
	    curadd_(&lunit[ip], &lunit[ipp]);
/*  ----------- Move third file currents into second files */
	    iqq = ip + *nplts;
/* L5: */
	    curequ_(&lunit[ipp], &lunit[iqq]);
	}
/* L6: */
    }
/*  ----------- Concatenate currents into common */
    curcom_(&lunit[1]);
    i__1 = *nplts;
    for (i__ = 2; i__ <= i__1; ++i__) {
/* L7: */
	curcat_(&lunit[i__]);
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* curcon_ */

