/* CVTROT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int cvtrot_(curi, rot, curo)
complex *curi;
real *rot;
complex *curo;
{
    /* System generated locals */
    integer i__1, i__2, i__3, i__4;
    complex q__1, q__2;

    /* Local variables */
    static integer i__, j;


/*  Rotation of Complex Vector by rotation matrix */

/*  CURI(3)    Input vector */
/*  ROT(3,3)   Rotation matrix */
/*  CURO(3)    Output vector */

    /* Parameter adjustments */
    --curo;
    rot -= 4;
    --curi;

    /* Function Body */
    for (i__ = 1; i__ <= 3; ++i__) {
	i__1 = i__;
	curo[i__1].r = (float)0., curo[i__1].i = (float)0.;
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    i__1 = i__;
	    i__2 = i__;
	    i__3 = j;
	    i__4 = j + i__ * 3;
	    q__2.r = rot[i__4] * curi[i__3].r, q__2.i = rot[i__4] * curi[i__3]
		    .i;
	    q__1.r = curo[i__2].r + q__2.r, q__1.i = curo[i__2].i + q__2.i;
	    curo[i__1].r = q__1.r, curo[i__1].i = q__1.i;
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* cvtrot_ */

