/* FFPATF.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int ffpatf_(lunit, xc, block, xb, theta, phi, etheta, ephi)
integer *lunit;
real *xc;
doublereal (*block) ();
real *xb, *theta, *phi;
complex *etheta, *ephi;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1;
    real r__1;
    complex q__1, q__2;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
    static complex conj;
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static integer ncur, i__, j, nctyp;
#define pk (equiv_0 + 2)
    extern /* Subroutine */ int ffdirc_();
    static integer nn;
    static real vp[3], vr[3], vt[3], xs[3];
    extern /* Subroutine */ int vgrejf_(), vgrhjf_();
    static complex eph, eth;

    /* Fortran I/O blocks */
    static cilist io___11 = { 0, 0, 0, 0, 1 };
    static cilist io___17 = { 0, 0, 0, 0, 0 };



/*  Far field pattern from currents in file */

/*  LUNIT     Logical unit of open file */
/*  XC(3)     Position of center of currents */
/*  BLOCK     Blockage function (external) = 1 when blocked */
/*  XB        Array of variables for blockage function */
/*  THETA     Angle from Z axis (boresight) (radians) */
/*  PHI       Spherical angle from X-axis (radians) */
/*  ETHETA    Electric field in Theta direction */
/*  EPHI      Electric field in Phi direction */

    /* Parameter adjustments */
    --xb;
    --xc;

    /* Function Body */
    ffdirc_(theta, phi, vr, vt, vp);
    io___11.ciunit = *lunit;
    s_rdue(&io___11);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
/* ------------- -j*2*Pi*Frequency*Mu */
    r__1 = -(*pk) * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
    ncur = ibuf[0];
    nctyp = ibuf[1];
    etheta->r = (float)0., etheta->i = (float)0.;
    ephi->r = (float)0., ephi->i = (float)0.;
    i__1 = ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___17.ciunit = *lunit;
	io___17.cirec = i__ + 1;
	s_rdue(&io___17);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    xs[j - 1] = frec[j - 1] + xc[j];
	}
	if ((*block)(&xb[1], xs, vr) == (float)0.) {
	    if (nctyp < 2) {
/* --------- Electric currents available */
		vgrejf_(vr, vt, vp, xs, pk, curj, &eth, &eph);
		q__2.r = eth.r * conj.r - eth.i * conj.i, q__2.i = eth.r * 
			conj.i + eth.i * conj.r;
		q__1.r = etheta->r + q__2.r, q__1.i = etheta->i + q__2.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__2.r = eph.r * conj.r - eph.i * conj.i, q__2.i = eph.r * 
			conj.i + eph.i * conj.r;
		q__1.r = ephi->r + q__2.r, q__1.i = ephi->i + q__2.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	    if (nctyp != 1) {
/* --------- Magnetic currents available */
		vgrhjf_(vr, vt, vp, xs, pk, curm, &eth, &eph);
		q__1.r = etheta->r - eth.r, q__1.i = etheta->i - eth.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__1.r = ephi->r - eph.r, q__1.i = ephi->i - eph.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	}
/* L2: */
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* ffpatf_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


