/* ffpati.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

struct {
    complex ers;
    real ths, urs;
    integer item;
} dielect_;

#define dielect_1 dielect_

/* Subroutine */ int ffpati_(xc, block, xb, theta, phi, etheta, ephi)
real *xc;
doublereal (*block) ();
real *xb, *theta, *phi;
complex *etheta, *ephi;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real pi = (float)3.141592654;
    static real zs = (float)376.73;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10, 
	    q__11;

    /* Builtin functions */
    void c_sqrt(), c_div(), c_sin(), c_cos();

    /* Local variables */
    static complex conj, curj[3], curm[3], zmte, zste, zmtm, zstm;
    static integer i__, j;
    extern /* Subroutine */ int ffdirc_();
    static real vp[3], vr[3], vt[3], xs[3];
    extern /* Subroutine */ int vgrejf_(), vgrhjf_();
    static complex eph, gte, eth, gtm;
    static real zte;
    static complex pzm;
    static real ztm;


/*  Far field pattern from currents in common for image in gr.pl. */
/*  with dielectric slab to top surface at Z = 0 */

/*  XC(3)     Position of center of currents */
/*  BLOCK     Blockage function (external) = 1 when blocked */
/*  XB        Array of variables for blockage function */
/*  THETA     Angle from Z axis (boresight) (radians) */
/*  PHI       Spherical angle from X-axis (radians) */
/*  ETHETA    Electric field in Theta direction */
/*  EPHI      Electric field in Phi direction */


/*  Dielectric slab common: /DIELECT/ */
/*  ERS	  Dielectric constant */
/* 	  ER*cmplx(1.,-(loss tangent)) or */
/* 	  cmplx(ER,-(conductivity(S/m))/(2*pi*8.854185e-12*frequency)) */
/*  THS	  Thickness (m) */
/*  URS	  Relative permeability */
/*  ITEM   If 1, use TEM approximation */

    /* Parameter adjustments */
    --xb;
    --xc;

    /* Function Body */
    ffdirc_(theta, phi, vr, vt, vp);
/* ------------- -j*2*Pi*Frequency*Mu */
    r__1 = -currenp_1.pkc * cc * (float)400. * pi;
    q__1.r = (float)0., q__1.i = r__1;
    conj.r = q__1.r, conj.i = q__1.i;
    etheta->r = (float)0., etheta->i = (float)0.;
    ephi->r = (float)0., ephi->i = (float)0.;
    i__1 = currenp_1.ncur;
    for (i__ = 1; i__ <= i__1; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    xs[j - 1] = currenp_1.posc[j + i__ * 3 - 4] + xc[j];
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curj[i__2].r = currenj_1.curja[i__3].r, curj[i__2].i = 
		    currenj_1.curja[i__3].i;
/* L1: */
	    i__2 = j - 1;
	    i__3 = j + i__ * 3 - 4;
	    curm[i__2].r = currenm_1.curma[i__3].r, curm[i__2].i = 
		    currenm_1.curma[i__3].i;
	}
	xs[2] = -xs[2];
	if ((*block)(&xb[1], xs, vr) == (float)0.) {
	    if (currenp_1.nctyp < 2) {
/* --------- Electric currents available */
		vgrejf_(vr, vt, vp, xs, &currenp_1.pkc, curj, &eth, &eph);
		q__2.r = eth.r * conj.r - eth.i * conj.i, q__2.i = eth.r * 
			conj.i + eth.i * conj.r;
		q__1.r = etheta->r + q__2.r, q__1.i = etheta->i + q__2.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__2.r = eph.r * conj.r - eph.i * conj.i, q__2.i = eph.r * 
			conj.i + eph.i * conj.r;
		q__1.r = ephi->r + q__2.r, q__1.i = ephi->i + q__2.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	    if (currenp_1.nctyp != 1) {
/* --------- Magnetic currents available */
		vgrhjf_(vr, vt, vp, xs, &currenp_1.pkc, curm, &eth, &eph);
		q__1.r = etheta->r - eth.r, q__1.i = etheta->i - eth.i;
		etheta->r = q__1.r, etheta->i = q__1.i;
		q__1.r = ephi->r - eph.r, q__1.i = ephi->i - eph.i;
		ephi->r = q__1.r, ephi->i = q__1.i;
	    }
	}
/* L2: */
    }
/* --------- Incident wave impedances */
    ztm = zs * vr[2];
    zte = zs / vr[2];
    q__5.r = dielect_1.urs * dielect_1.ers.r, q__5.i = dielect_1.urs * 
	    dielect_1.ers.i;
    q__4.r = q__5.r - (float)1., q__4.i = q__5.i;
/* Computing 2nd power */
    r__2 = vr[2];
    r__1 = r__2 * r__2;
    q__3.r = q__4.r + r__1, q__3.i = q__4.i;
    c_sqrt(&q__2, &q__3);
    q__1.r = currenp_1.pkc * q__2.r, q__1.i = currenp_1.pkc * q__2.i;
    pzm.r = q__1.r, pzm.i = q__1.i;
    q__3.r = zs * pzm.r, q__3.i = zs * pzm.i;
    q__2.r = q__3.r / currenp_1.pkc, q__2.i = q__3.i / currenp_1.pkc;
    c_div(&q__1, &q__2, &dielect_1.ers);
    zmtm.r = q__1.r, zmtm.i = q__1.i;
    r__1 = zs * currenp_1.pkc * dielect_1.urs;
    q__2.r = r__1, q__2.i = (float)0.;
    c_div(&q__1, &q__2, &pzm);
    zmte.r = q__1.r, zmte.i = q__1.i;
    if (dielect_1.item == 1) {
	r__1 = currenp_1.pkc * dielect_1.ths;
	c_sqrt(&q__7, &dielect_1.ers);
	q__6.r = r__1 * q__7.r, q__6.i = r__1 * q__7.i;
	c_sin(&q__5, &q__6);
	q__4.r = zs * q__5.r, q__4.i = zs * q__5.i;
	r__2 = currenp_1.pkc * dielect_1.ths;
	c_sqrt(&q__10, &dielect_1.ers);
	q__9.r = r__2 * q__10.r, q__9.i = r__2 * q__10.i;
	c_cos(&q__8, &q__9);
	c_div(&q__3, &q__4, &q__8);
	q__2.r = q__3.r * (float)0. - q__3.i * (float)-1., q__2.i = q__3.r * (
		float)-1. + q__3.i * (float)0.;
	c_sqrt(&q__11, &dielect_1.ers);
	c_div(&q__1, &q__2, &q__11);
	zstm.r = q__1.r, zstm.i = q__1.i;
	zste.r = zstm.r, zste.i = zstm.i;
    } else if (dielect_1.item == -1) {
	q__5.r = dielect_1.ths * pzm.r, q__5.i = dielect_1.ths * pzm.i;
	c_sin(&q__4, &q__5);
	q__3.r = zmtm.r * q__4.r - zmtm.i * q__4.i, q__3.i = zmtm.r * q__4.i 
		+ zmtm.i * q__4.r;
	q__7.r = dielect_1.ths * pzm.r, q__7.i = dielect_1.ths * pzm.i;
	c_cos(&q__6, &q__7);
	c_div(&q__2, &q__3, &q__6);
	q__1.r = q__2.r * (float)0. - q__2.i * (float)-1., q__1.i = q__2.r * (
		float)-1. + q__2.i * (float)0.;
	zstm.r = q__1.r, zstm.i = q__1.i;
	q__5.r = dielect_1.ths * pzm.r, q__5.i = dielect_1.ths * pzm.i;
	c_sin(&q__4, &q__5);
	q__3.r = zmte.r * q__4.r - zmte.i * q__4.i, q__3.i = zmte.r * q__4.i 
		+ zmte.i * q__4.r;
	q__7.r = dielect_1.ths * pzm.r, q__7.i = dielect_1.ths * pzm.i;
	c_cos(&q__6, &q__7);
	c_div(&q__2, &q__3, &q__6);
	q__1.r = q__2.r * (float)0. - q__2.i * (float)-1., q__1.i = q__2.r * (
		float)-1. + q__2.i * (float)0.;
	zste.r = q__1.r, zste.i = q__1.i;
    } else if (dielect_1.item == 0) {
	zstm.r = zmtm.r, zstm.i = zmtm.i;
	zste.r = zmte.r, zste.i = zmte.i;
    }
/* --------- Find the reflection coefficients of two polarizations */
    q__2.r = ztm - zstm.r, q__2.i = -zstm.i;
    q__3.r = ztm + zstm.r, q__3.i = zstm.i;
    c_div(&q__1, &q__2, &q__3);
    gtm.r = q__1.r, gtm.i = q__1.i;
    q__2.r = zste.r - zte, q__2.i = zste.i;
    q__3.r = zste.r + zte, q__3.i = zste.i;
    c_div(&q__1, &q__2, &q__3);
    gte.r = q__1.r, gte.i = q__1.i;
/* --------- Reduce reflected fields */
    q__2.r = -etheta->r, q__2.i = -etheta->i;
    q__1.r = q__2.r * gtm.r - q__2.i * gtm.i, q__1.i = q__2.r * gtm.i + 
	    q__2.i * gtm.r;
    etheta->r = q__1.r, etheta->i = q__1.i;
    q__1.r = ephi->r * gte.r - ephi->i * gte.i, q__1.i = ephi->r * gte.i + 
	    ephi->i * gte.r;
    ephi->r = q__1.r, ephi->i = q__1.i;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* ffpati_ */

