/* GREJC.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int grejc_(xf, xs, pk, gej)
real *xf, *xs, *pk;
complex *gej;
{
    /* Initialized data */

    static real fpi = (float)12.5663706;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;
    complex q__1, q__2, q__3, q__4, q__5;

    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static complex conn, conp;
    static integer i__, j;
    static real r__, phase;
    extern /* Subroutine */ int rrmat_();
    static real rr[9]	/* was [3][3] */;
    static complex con;


/*  Complete: Near and far field */

/*  Dyadic Green's function between source current density: J */
/*  and electric field: E when multiplied by -j(2*pi*frequency)*mu */
/*  Dyadic Green's function between source current magnetic density: M */
/*  and the magnetic field: H when multiplied by -j(2*Pi*freq*epsilon) */

/*  XF(3)    Field point (units must match PK) */
/*  XS(3)    Source point (units must match PK) */
/*  PK       Propagation constant = 2*Pi/wavelength */
/*  GEJ(3,3) Free-space Dyadic Green's function (complex) */

    /* Parameter adjustments */
    gej -= 4;
    --xs;
    --xf;

    /* Function Body */
    rrmat_(&xf[1], &xs[1], rr, &r__);
    r__1 = (float)1. / r__;
    q__5.r = r__1, q__5.i = *pk;
    q__4.r = q__5.r * (float)2., q__4.i = q__5.i * (float)2.;
/* Computing 2nd power */
    r__3 = *pk;
    r__2 = r__3 * r__3;
    q__3.r = q__4.r / r__2, q__3.i = q__4.i / r__2;
    q__2.r = q__3.r / r__, q__2.i = q__3.i / r__;
    q__1.r = q__2.r - (float)1., q__1.i = q__2.i;
    con.r = q__1.r, con.i = q__1.i;
    r__1 = (float)1. / (r__ * *pk);
    q__2.r = r__1, q__2.i = (float)1.;
    r__2 = r__ * *pk;
    q__1.r = q__2.r / r__2, q__1.i = q__2.i / r__2;
    conn.r = q__1.r, conn.i = q__1.i;
    phase = *pk * r__;
    r__1 = cos(phase);
    r__2 = -sin(phase);
    q__3.r = r__1, q__3.i = r__2;
    q__2.r = q__3.r / fpi, q__2.i = q__3.i / fpi;
    q__1.r = q__2.r / r__, q__1.i = q__2.i / r__;
    conp.r = q__1.r, conp.i = q__1.i;
    for (i__ = 1; i__ <= 3; ++i__) {
	for (j = 1; j <= 3; ++j) {
	    i__1 = i__ + j * 3;
	    q__2.r = con.r + conn.r, q__2.i = con.i + conn.i;
	    i__2 = i__ + j * 3 - 4;
	    q__1.r = rr[i__2] * q__2.r, q__1.i = rr[i__2] * q__2.i;
	    gej[i__1].r = q__1.r, gej[i__1].i = q__1.i;
	    if (i__ == j) {
		i__1 = i__ + j * 3;
		i__2 = i__ + j * 3;
		q__2.r = gej[i__2].r + (float)1., q__2.i = gej[i__2].i;
		q__1.r = q__2.r - conn.r, q__1.i = q__2.i - conn.i;
		gej[i__1].r = q__1.r, gej[i__1].i = q__1.i;
	    }
/* L1: */
	    i__1 = i__ + j * 3;
	    i__2 = i__ + j * 3;
	    q__1.r = conp.r * gej[i__2].r - conp.i * gej[i__2].i, q__1.i = 
		    conp.r * gej[i__2].i + conp.i * gej[i__2].r;
	    gej[i__1].r = q__1.r, gej[i__1].i = q__1.i;
	}
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* grejc_ */

