/* GRHJC.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int grhjc_(xf, xs, pk, ghj)
real *xf, *xs, *pk;
complex *ghj;
{
    /* Initialized data */

    static real fpi = (float)12.5663706;

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2, r__3;
    complex q__1, q__2, q__3, q__4, q__5, q__6;

    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static complex conp;
    static integer i__, j;
    static real r__, phase, rci[9]	/* was [3][3] */;
    extern /* Subroutine */ int rcrossi_();


/*  Complete: Near and Far Field */

/*  Dyadic Green's function between source current density: J */
/*  and the magnetic field: H  when multiplied by j  or */
/*  Dyadic Green's function between source magnetic current density: M */
/*  and the electric field: E when multiplied by -j */

/*  XF(3)   Field point */
/*  XS(3)   Source point */
/*  PK      Propagation constant: units of XF, XS, PK should match */
/*          If the fields are expressed V/m, then the units should be m */

    /* Parameter adjustments */
    ghj -= 4;
    --xs;
    --xf;

    /* Function Body */
    rcrossi_(&xf[1], &xs[1], rci, &r__);
    phase = *pk * r__;
    r__1 = (float)1. / r__;
    q__5.r = r__1, q__5.i = *pk;
    q__4.r = -q__5.r, q__4.i = -q__5.i;
    r__2 = cos(phase);
    r__3 = -sin(phase);
    q__6.r = r__2, q__6.i = r__3;
    q__3.r = q__4.r * q__6.r - q__4.i * q__6.i, q__3.i = q__4.r * q__6.i + 
	    q__4.i * q__6.r;
    q__2.r = q__3.r / fpi, q__2.i = q__3.i / fpi;
    q__1.r = q__2.r / r__, q__1.i = q__2.i / r__;
    conp.r = q__1.r, conp.i = q__1.i;
    for (i__ = 1; i__ <= 3; ++i__) {
	for (j = 1; j <= 3; ++j) {
/* L1: */
	    i__1 = i__ + j * 3;
	    i__2 = i__ + j * 3 - 4;
	    q__1.r = rci[i__2] * conp.r, q__1.i = rci[i__2] * conp.i;
	    ghj[i__1].r = q__1.r, ghj[i__1].i = q__1.i;
	}
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* grhjc_ */

