/* PO06.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer ncur, nctyp;
    real pkc, posc[6000]	/* was [3][2000] */;
} currenp_;

#define currenp_1 currenp_

struct {
    complex curja[6000]	/* was [3][2000] */;
} currenj_;

#define currenj_1 currenj_

struct {
    complex curma[6000]	/* was [3][2000] */;
} currenm_;

#define currenm_1 currenm_

/* Table of constant values */

static integer c__19 = 19;
static integer c__4 = 4;
static integer c__1 = 1;
static integer c__2 = 2;
static integer c__361 = 361;

/* Main program */ MAIN__()
{
    /* Initialized data */

    static real xc[3] = { (float)0.,(float)0.,(float)0. };
    static real tr = (float).01745329;
    static real gcons = (float).182637;

    /* Format strings */
    static char fmt_1[] = "(\002 Enter sphere radius (wavelengths) \002,$)";
    static char fmt_2[] = "(\002 Enter length of patch increments \002,$)";
    static char fmt_5[] = "(\002 Enter Phi \002,$)";

    /* System generated locals */
    olist o__1;

    /* Builtin functions */
    integer f_open(), s_wsfe(), e_wsfe(), s_rsle(), do_lio(), e_rsle();
    /* Subroutine */ int s_stop();
    double c_abs(), r_lg10();

    /* Local variables */
    static complex ephi;
    extern /* Subroutine */ int plot_();
    static integer i__;
    extern /* Subroutine */ int elecc_();
    static real field[361], angle[361], alinc, theta, xb[1], pk;
    static integer np, nt;
    extern /* Subroutine */ int blockn_();
    static complex etheta;
    extern /* Subroutine */ int ffpatr_(), sphgeo_();
    static real radius;
    extern /* Subroutine */ int curcom_(), sphcur_();
    static real far__[361], phi;

    /* Fortran I/O blocks */
    static cilist io___4 = { 0, 6, 0, fmt_1, 0 };
    static cilist io___5 = { 0, 5, 0, 0, 0 };
    static cilist io___7 = { 0, 6, 0, fmt_2, 0 };
    static cilist io___8 = { 0, 5, 0, 0, 0 };
    static cilist io___21 = { 0, 6, 0, fmt_5, 0 };
    static cilist io___22 = { 0, 5, 0, 0, 0 };



/*  FORTRAN repeat of example: Aperture Fields on Sphere from */
/*  Incremental electric dipole */


/*  CURRENT Common */

/*  NCUR     Number of points */
/*  NCTYP    Current types: 0 both, 1 electric only, 2 magnetic only */
/*  PKC      Propagation constant (1./meters) */
/*  POSC     Position of current element (meters) */
/*  CURJA    Electric current * area rectangular components (complex) */
/*  CURMA    Magnetic current * area rectangular components (complex) */

/* ------- Open random access file for currents */
    o__1.oerr = 0;
    o__1.ounit = 19;
    o__1.ofnmlen = 8;
    o__1.ofnm = "PO01.DAT";
    o__1.orl = 76;
    o__1.osta = 0;
    o__1.oacc = "DIRECT";
    o__1.ofm = 0;
    o__1.oblnk = 0;
    f_open(&o__1);
/* ------- Create file with currents */
    elecc_(&c__19);
    curcom_(&c__19);
    s_wsfe(&io___4);
    e_wsfe();
    s_rsle(&io___5);
    do_lio(&c__4, &c__1, (char *)&radius, (ftnlen)sizeof(real));
    e_rsle();
    s_wsfe(&io___7);
    e_wsfe();
    s_rsle(&io___8);
    do_lio(&c__4, &c__1, (char *)&alinc, (ftnlen)sizeof(real));
    e_rsle();
    if (nt * np > 2000) {
	s_stop("", 0L);
    }
    phi = (float)0.;
/* ------- Calculate far field of incremental dipole */
    for (i__ = 1; i__ <= 361; ++i__) {
	angle[i__ - 1] = (real) (i__ - 1);
	theta = angle[i__ - 1] * tr;
	ffpatr_(xc, blockn_, xb, &theta, &phi, &etheta, &ephi);
	far__[i__ - 1] = gcons * c_abs(&etheta);
	if (far__[i__ - 1] > (float)1e-12) {
	    far__[i__ - 1] = r_lg10(&far__[i__ - 1]) * (float)20.;
	} else {
	    far__[i__ - 1] = (float)-240.;
	}
/* L3: */
    }
/* -------- Create sphere geometry file */
    sphgeo_(&radius, &alinc, &c__19, &c__2);
/* -------- Find aperture currents on sphere */
    pk = currenp_1.pkc;
    sphcur_(&pk, blockn_, xb, &c__19);
    curcom_(&c__19);
/* -------- Calculate fields from sphere currents */
L6:
    s_wsfe(&io___21);
    e_wsfe();
    s_rsle(&io___22);
    do_lio(&c__4, &c__1, (char *)&phi, (ftnlen)sizeof(real));
    e_rsle();
    if (phi < (float)0.) {
	s_stop("", 0L);
    }
    for (i__ = 1; i__ <= 361; ++i__) {
	theta = angle[i__ - 1] * tr;
	ffpatr_(xc, blockn_, xb, &theta, &phi, &etheta, &ephi);
	field[i__ - 1] = gcons * c_abs(&etheta);
	if (field[i__ - 1] > (float)1e-12) {
	    field[i__ - 1] = r_lg10(&field[i__ - 1]) * (float)20.;
	} else {
	    field[i__ - 1] = (float)-240.;
	}
/* L4: */
    }
    plot_(angle, far__, &c__361);
    plot_(angle, field, &c__361);
    goto L6;
} /* MAIN__ */

/* Subroutine */ int elecc_(lunit)
integer *lunit;
{
    /* Initialized data */

    static real pi = (float)3.14159265;

    /* System generated locals */
    real r__1;
    static real equiv_0[19];
    static complex equiv_1[10];

    /* Builtin functions */
    integer s_wdue(), do_uio(), e_wdue();
    double sqrt();

    /* Local variables */
#define frec ((real *)equiv_1)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_1 + 7))
#define pk (equiv_0 + 2)
    static integer nn;

    /* Fortran I/O blocks */
    static cilist io___29 = { 0, 0, 0, 0, 1 };
    static cilist io___31 = { 0, 0, 0, 0, 2 };



/*  Electric current element */

/*  LUNIT   Logical unit of random access file with currents */

    *pk = pi * (float)2.;
/* ----------- Write first record: # points, current type, Propagation */
    ibuf[0] = 1;
    ibuf[1] = 1;
    io___29.ciunit = *lunit;
    s_wdue(&io___29);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
    curj[0].r = (float)0., curj[0].i = (float)0.;
    curj[1].r = (float)0., curj[1].i = (float)0.;
    r__1 = sqrt((float)3. / (pi * (float)2. * (float)376.73));
    curj[2].r = r__1, curj[2].i = (float)0.;
    frec[0] = (float)0.;
    frec[1] = (float)0.;
    frec[2] = (float)0.;
    io___31.ciunit = *lunit;
    s_wdue(&io___31);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* elecc_ */

#undef pk
#undef curj
#undef ibuf
#undef frec


/* Main program alias */ int po06_ () { MAIN__ (); }
