/* REFPCU.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int refpcu_(pkc, xinc, hfield, block, xb, lunit, inout)
real *pkc, *xinc;
complex *hfield;
doublereal (*block) ();
real *xb;
integer *lunit, *inout;
{
    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;
    complex q__1;
    static real equiv_0[19];
    static complex equiv_2[10];

    /* Builtin functions */
    integer s_rdue(), do_uio(), e_rdue(), s_wdue(), e_wdue();
    double cos(), sin();

    /* Local variables */
#define frec ((real *)equiv_2)
#define ibuf ((integer *)equiv_0)
#define curj ((complex *)((integer *)equiv_2 + 7))
#define curm ((complex *)((integer *)equiv_2 + 13))
    static complex unit[3];
    static integer i__, j;
    static real phase;
#define pk (equiv_0 + 2)
    static integer nn;
    extern /* Subroutine */ int ccross_();
    static complex pha;
    extern doublereal dot_();

    /* Fortran I/O blocks */
    static cilist io___6 = { 0, 0, 0, 0, 1 };
    static cilist io___8 = { 0, 0, 0, 0, 1 };
    static cilist io___10 = { 0, 0, 0, 0, 0 };
    static cilist io___15 = { 0, 0, 0, 0, 0 };



/*  Reflector surface currents added to Geometry File */
/*  Due to Plane Wave Incident */

/*  PKC      Propagation constant */
/*  XINC(3)  Unit vector in direction of plane wave */
/*  HFIELD   Incident magnetic field */
/*  BLOCK    Blockage function (external) = 1 when blocked */
/*  XB       Array of variables for blockage function */
/*  LUNIT    Logical unit of random access currents file */
/*  INOUT    +1 only use when normal towards plane wave */
/*           -1 only use when normal away from plane wave */
/*            0 either */

    /* Parameter adjustments */
    --xb;
    --hfield;
    --xinc;

    /* Function Body */
    io___6.ciunit = *lunit;
    s_rdue(&io___6);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_rdue();
    *pk = *pkc;
    ibuf[1] = 1;
    io___8.ciunit = *lunit;
    s_wdue(&io___8);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/*  ------------- Loop over current patches */
    i__1 = ibuf[0];
    for (i__ = 1; i__ <= i__1; ++i__) {
	io___10.ciunit = *lunit;
	io___10.cirec = i__ + 1;
	s_rdue(&io___10);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_rdue();
/*  ------------- Check for blockage */
	if ((*block)(&xb[1], frec, &xinc[1]) != (float)1. && dot_(&xinc[1], &
		frec[4]) * *inout >= (float)0.) {
/*  ------------- Find distance to reference plane */
	    phase = dot_(frec, &xinc[1]) * *pkc;
	    r__1 = cos(phase);
	    r__2 = sin(phase);
	    q__1.r = r__1, q__1.i = r__2;
	    pha.r = q__1.r, pha.i = q__1.i;
	    for (j = 1; j <= 3; ++j) {
		i__2 = j - 1;
		curm[i__2].r = (float)0., curm[i__2].i = (float)0.;
/* L2: */
		i__2 = j - 1;
		r__1 = frec[j + 3] * (float)2. * frec[3];
		q__1.r = r__1 * pha.r, q__1.i = r__1 * pha.i;
		unit[i__2].r = q__1.r, unit[i__2].i = q__1.i;
	    }
	    ccross_(unit, &hfield[1], curj);
	} else {
/*  ------------- Blocked */
	    for (j = 1; j <= 3; ++j) {
/* L3: */
		i__2 = j - 1;
		curj[i__2].r = (float)0., curj[i__2].i = (float)0.;
	    }
	}
/* L4: */
	io___15.ciunit = *lunit;
	io___15.cirec = i__ + 1;
	s_wdue(&io___15);
	for (nn = 1; nn <= 19; ++nn) {
	    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real));
	}
	e_wdue();
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* refpcu_ */

#undef pk
#undef curm
#undef curj
#undef ibuf
#undef frec


