/* RETSP.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int retsp_(x, s)
real *x, *s;
{
    /* Builtin functions */
    double acos(), sqrt(), atan2();

    /* Local variables */
    static real pi;


/*  Rectangular to Spherical Coordinates */
/*  X - (X,Y,Z) */
/*  S - Radius, Theta (radians), Phi (radians) */

    /* Parameter adjustments */
    --s;
    --x;

    /* Function Body */
    pi = acos((float)0.) * (float)2.;
    s[1] = sqrt(x[1] * x[1] + x[2] * x[2] + x[3] * x[3]);
    s[2] = (float)0.;
    s[3] = (float)0.;
    if (s[1] <= (float)0.) {
	return 0;
    }
    s[2] = acos(x[3] / s[1]);
    if (s[2] == (float)0. || s[2] == pi) {
	return 0;
    }
    s[3] = atan2(x[2], x[1]);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* retsp_ */

