/* RINPAT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rinpat_(rot, inst, theta, phi, etheta, ephi)
real *rot;
integer *inst;
real *theta, *phi;
complex *etheta, *ephi;
{
    /* Initialized data */

    static real tr = (float).01745329;

    /* System generated locals */
    real r__1, r__2;
    complex q__1, q__2, q__3;

    /* Local variables */
    static complex ephe;
    static real thete, ph, th;
    extern /* Subroutine */ int ffdirc_();
    static real vp[3], vr[3], vt[3];
    static complex ethete;
    extern /* Subroutine */ int patind_(), patrot_();
    static real phe;
    extern doublereal dot_();
    static real vpp[3], vpr[3], vtp[3], vrr[3], vtr[3];


/*  Rotated */
/*  Interpolated Measured Pattern */

/*  ROT(3,3) Rotation matrix */
/*  INST   - 1 Initialize: Read from file of ASCII listing of data */
/*           2 Return pattern value */
/*  THETA    Pattern angle (radians) (Value to add to bias to gain */
/*              on initialization dB) */
/*  PHI      Pattern angle (radians) (Value to add to bias to gain */
/*              on initialization dB) */
/*  ETHETA   Theta component  V/m for 1 watt radiated power at 1 m. */
/*  EPHI     Phi component    V/m for 1 watt radiated power at 1 m. */

    /* Parameter adjustments */
    rot -= 4;

    /* Function Body */
    if (*inst == 1) {
	patind_(inst, theta, phi, etheta, ephi);
    } else {
/* ------------ Find unit vectors for pattern direction */
	ffdirc_(theta, phi, vr, vt, vp);
/* ------------ Express VR in element coordinates for pattern */
/*              directions & Express VT and VP in element coordinates 
*/
	patrot_(&rot[4], vr, vt, vp, &thete, &phe, vtp, vpp);
/* ------------ Find pattern */
	th = thete / tr;
	ph = phe / tr;
	patind_(inst, &th, &ph, &ethete, &ephe);
/* ------------ Find unit vectors in element coordinate system */
	ffdirc_(&thete, &phe, vrr, vtr, vpr);
/* ------------ Project element components onto re-expressed */
/*              unit vectors to find components */
	r__1 = dot_(vtr, vtp);
	q__2.r = r__1 * ethete.r, q__2.i = r__1 * ethete.i;
	r__2 = dot_(vpr, vtp);
	q__3.r = r__2 * ephe.r, q__3.i = r__2 * ephe.i;
	q__1.r = q__2.r + q__3.r, q__1.i = q__2.i + q__3.i;
	etheta->r = q__1.r, etheta->i = q__1.i;
	r__1 = dot_(vtr, vpp);
	q__2.r = r__1 * ethete.r, q__2.i = r__1 * ethete.i;
	r__2 = dot_(vpr, vpp);
	q__3.r = r__2 * ephe.r, q__3.i = r__2 * ephe.i;
	q__1.r = q__2.r + q__3.r, q__1.i = q__2.i + q__3.i;
	ephi->r = q__1.r, ephi->i = q__1.i;
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rinpat_ */

