/* RPPERM.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rpperm_(p, rl, w, pos, am, iedge, pol)
real *p, *rl, *w, *pos;
complex *am;
integer *iedge;
real *pol;
{
    /* Initialized data */

    static real pi = (float)3.141592654;
    static real s2 = (float)1.4142135;

    /* System generated locals */
    real r__1;
    complex q__1, q__2, q__3, q__4;

    /* Builtin functions */
    double sin();


/*  Perimeter function of rectangular patch */

/*  P   Perimeter value */
/*  RL  Resonant length along X axis */
/*  W   Non-resonant width */
/*  POS    Position on patch centered on origin */
/*  AM(3)  Normalized magnetic current direction */
/*  IEDGE  Edge number: Intersects axis: 1 +X, 2 +Y, 3 -X, 4 -Y */
/*  POL    Polarization: 0 Linear, -1 RHC, +1 LHC */

    /* Parameter adjustments */
    --am;
    --pos;

    /* Function Body */
    pos[3] = (float)0.;
    am[3].r = (float)0., am[3].i = (float)0.;
    if (*iedge == 1) {
	pos[1] = *rl / (float)2.;
	pos[2] = -(*w) / (float)2. + *p;
	am[1].r = (float)0., am[1].i = (float)0.;
	am[2].r = (float)1., am[2].i = (float)0.;
	if (*pol != (float)0.) {
	    q__4.r = (float)0., q__4.i = *pol;
	    r__1 = sin(pos[2] * pi / (float)2.);
	    q__3.r = r__1 * q__4.r, q__3.i = r__1 * q__4.i;
	    q__2.r = am[2].r - q__3.r, q__2.i = am[2].i - q__3.i;
	    q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	    am[2].r = q__1.r, am[2].i = q__1.i;
	}
    } else if (*iedge == 2) {
	pos[1] = -(*rl) / (float)2. + *p;
	pos[2] = *w / (float)2.;
	r__1 = -sin(pos[1] * pi / (float)2.);
	am[1].r = r__1, am[1].i = (float)0.;
	am[2].r = (float)0., am[2].i = (float)0.;
	if (*pol != (float)0.) {
	    q__3.r = (float)0., q__3.i = *pol;
	    q__2.r = am[1].r - q__3.r, q__2.i = am[1].i - q__3.i;
	    q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	    am[1].r = q__1.r, am[1].i = q__1.i;
	}
    } else if (*iedge == 3) {
	pos[1] = -(*rl) / (float)2.;
	pos[2] = -(*w) / (float)2. + *p;
	am[1].r = (float)0., am[1].i = (float)0.;
	am[2].r = (float)1., am[2].i = (float)0.;
	if (*pol != (float)0.) {
	    q__4.r = (float)0., q__4.i = *pol;
	    r__1 = sin(pos[2] * pi / (float)2.);
	    q__3.r = r__1 * q__4.r, q__3.i = r__1 * q__4.i;
	    q__2.r = am[2].r + q__3.r, q__2.i = am[2].i + q__3.i;
	    q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	    am[2].r = q__1.r, am[2].i = q__1.i;
	}
    } else if (*iedge == 4) {
	pos[1] = -(*rl) / (float)2. + *p;
	pos[2] = -(*w) / (float)2.;
	r__1 = sin(pos[1] * pi / (float)2.);
	am[1].r = r__1, am[1].i = (float)0.;
	am[2].r = (float)0., am[2].i = (float)0.;
	if (*pol != (float)0.) {
	    q__3.r = (float)0., q__3.i = *pol;
	    q__2.r = am[1].r - q__3.r, q__2.i = am[1].i - q__3.i;
	    q__1.r = q__2.r / s2, q__1.i = q__2.i / s2;
	    am[1].r = q__1.r, am[1].i = q__1.i;
	}
    }
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rpperm_ */

