/* RRMAT.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int rrmat_(xf, xs, rr, r__)
real *xf, *xs, *rr, *r__;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__, j;
    static real dd[3];


/*  Matrix RR between field point: XF(3) and source point: XS(3) */
/*  Outputs: RR  Matrix, R distance between points */

    /* Parameter adjustments */
    rr -= 4;
    --xs;
    --xf;

    /* Function Body */
    *r__ = (float)0.;
    for (i__ = 1; i__ <= 3; ++i__) {
	dd[i__ - 1] = xf[i__] - xs[i__];
/* L1: */
/* Computing 2nd power */
	r__1 = dd[i__ - 1];
	*r__ += r__1 * r__1;
    }
    for (i__ = 1; i__ <= 3; ++i__) {
	for (j = 1; j <= 3; ++j) {
/* L2: */
	    rr[i__ + j * 3] = dd[i__ - 1] * dd[j - 1] / *r__;
	}
    }
    *r__ = sqrt(*r__);
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* rrmat_ */

