/* SCUTAL.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Complex */ VOID scutal_( ret_val, rl1, rl2, f, x, y, nint, pol)
complex * ret_val;
real *rl1, *rl2, *f, *x, *y;
integer *nint;
real *pol;
{
    /* Initialized data */

    static real cc = (float).2997925;
    static real xc[3] = { (float)0.,(float)0.,(float)0. };

    /* System generated locals */
    integer i__1;
    real r__1;
    complex q__1, q__2, q__3;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__, iedge;
    extern /* Complex */ VOID ccdot_();
    static real wavel, v1;
    static complex am[3], efield[3];
    static real hp, xb[1];
    static complex hfield[3];
    static real xf[3];
    static complex ss;
    extern /* Subroutine */ int blockn_();
    extern doublereal rradcn_();
    extern /* Subroutine */ int nfpatr_(), rpperm_();
    static real pos, wid1, wid2;


/*  Mutual admittance between two square patch antennas */
/*  Using currents in common for first patch */

/*  RL1     Resonant length of 1st patch (cm) */
/*  RL2     Resonant length of 2nd patch (cm) */
/*  F       Frequency (GHz) */
/*  X,Y     Position of 2nd patch (cm) */
/*  NINT    Points in integral along edges */
/*  POL     Polarization: 0 Linear, -1 RHC, +1 LHC */

/*  Note:   Feeds located on X axis */

    wid1 = *rl1 * (float).01;
    wid2 = *rl2 * (float).01;
    wavel = cc / *f;
    hp = wid2 / *nint;
    r__1 = wid1 / wavel;
    v1 = sqrt((float)1. / rradcn_(&r__1));
/* ------------------- Loop on edges of second patch */
    ss.r = (float)0., ss.i = (float)0.;
    for (iedge = 1; iedge <= 4; ++iedge) {
/* ------------------- Find reaction along edge */
	i__1 = *nint;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    pos = hp * (i__ - (float).5);
	    rpperm_(&pos, &wid2, &wid2, xf, am, &iedge, pol);
	    xf[0] += *x * (float).01;
	    xf[1] += *y * (float).01;
/* ------------------- Find fields at point due to 1st patch */
	    nfpatr_(xc, blockn_, xb, xf, efield, hfield);
/* ------------------- Find reaction at point */
/* L1: */
	    ccdot_(&q__3, hfield, am);
	    q__2.r = hp * q__3.r, q__2.i = hp * q__3.i;
	    q__1.r = q__2.r + ss.r, q__1.i = q__2.i + ss.i;
	    ss.r = q__1.r, ss.i = q__1.i;
	}
    }
/* ------------------- Half space radiation, reduce by 1/2 */
    q__3.r = -ss.r, q__3.i = -ss.i;
    q__2.r = q__3.r / v1, q__2.i = q__3.i / v1;
    q__1.r = q__2.r / (float)2., q__1.i = q__2.i / (float)2.;
     ret_val->r = q__1.r,  ret_val->i = q__1.i;
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return ;
} /* scutal_ */

