/* SPHGEO.f -- translated by f2c (version 19951021).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int sphgeo_(radius, alinc, lunit, nemi)
real *radius, *alinc;
integer *lunit, *nemi;
{
    /* Initialized data */

    static real pi = (float)3.141592654;

    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1;

    /* Builtin functions */
    double cos(), sin();
    integer s_wdue(), do_uio(), e_wdue();

    /* Local variables */
    static real frec[19], delp;
    static integer ibuf[19];
    static real delt, scon;
    static integer i__, j, k, l, n;
    extern /* Subroutine */ int arads_();
    static real dl;
    static integer nn, np, nt;
    static real sp[3];

    /* Fortran I/O blocks */
    static cilist io___15 = { 0, 0, 0, 0, 0 };
    static cilist io___18 = { 0, 0, 0, 0, 1 };



/*  Geometry portion of sphere in currents file */

/*  RADIUS  Radius of sphere (m) */
/*  ALINC   Length increment of patches */
/*  LUNIT   Logical unit of random access file for currents */
/*  NEMI    1 Upper hemisphere only, 2 Sphere */

    sp[0] = (float)1.;
    nt = *radius * pi / *alinc / (float)2. + (float).1;
    delt = pi / nt / (float)2.;
    l = 1;
/* ------------ Loop on hemisphere */
    i__1 = *nemi;
    for (n = 1; n <= i__1; ++n) {
	scon = (n - 1) * pi / (float)2.;
/* ------------ Loop on Theta */
	i__2 = nt;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    sp[1] = delt * (i__ - (float).5) + scon;
	    dl = (r__1 = cos(sp[1] - delt * (float).5) - cos(sp[1] + delt * (
		    float).5), dabs(r__1)) * *radius;
/* ------------ Loop on Phi */
	    np = pi * (float)2. * sin(sp[1]) * *radius / *alinc + (float)1.;
	    delp = pi * (float)2. / np;
	    i__3 = np;
	    for (j = 1; j <= i__3; ++j) {
		sp[2] = delp * (j - 1);
/* ------------ Differential area */
		frec[3] = dl * delp * *radius;
/* ------------ Unit normal */
		arads_(sp, &frec[4]);
		for (k = 1; k <= 3; ++k) {
/* L1: */
		    frec[k - 1] = *radius * frec[k + 3];
		}
		++l;
/* L2: */
		io___15.ciunit = *lunit;
		io___15.cirec = l;
		s_wdue(&io___15);
		for (nn = 1; nn <= 19; ++nn) {
		    do_uio(&c__1, (char *)&frec[nn - 1], (ftnlen)sizeof(real))
			    ;
		}
		e_wdue();
	    }
	}
/* L3: */
    }
    ibuf[0] = l - 1;
    io___18.ciunit = *lunit;
    s_wdue(&io___18);
    for (nn = 1; nn <= 19; ++nn) {
	do_uio(&c__1, (char *)&ibuf[nn - 1], (ftnlen)sizeof(integer));
    }
    e_wdue();
/* ------ Antenna Engineering using Physical Optics, Artech */
/* ------ Code by T.A. Milligan */
    return 0;
} /* sphgeo_ */

