      PROGRAM CONRCS
C
C  RCS of Truncated cone using PO
C
C  Written   25 Apr 95
C
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
C
      DIMENSION FREQ(361),VR(3),VT(3),VP(3),XC(3),
     1 UNITS(4),XBB(112),RCS(361),P1(3),P2(3),AXS(3)
      INTEGER*4 IBUF(19)
      COMPLEX HFIELD(3),CURJA,CURMA,ETHETA,EPHI
      COMMON /CURRENP/NCUR,NCTYP,PKC,POSC(3,4000)
      COMMON /CURRENJ/CURJA(3,4000)
      COMMON /CURRENM/CURMA(3,4000)
      CHARACTER CUNIT(4)*4
      EXTERNAL BLOCKN
      DATA TR/.01745329/,RCONS/.009409677/,XC/0.,0.,0./,
     1 UNITS/.0254,.3048,.01,1./,CUNIT/' in.',' ft.',' cm.',' m. '/,
     2 PI/3.141592654/,CC/.2997925/
      OPEN(66,FILE='conrcs.out')
      OPEN(19,FILE='conrcs.dat',ACCESS='DIRECT',RECL=76)
      WRITE(6,1)
    1 FORMAT(' RCS of truncated cone; Enter lower upper diameters ',$)
      READ(5,*)DIA1,DIA2
      WRITE(6,3)
    3 FORMAT(' Enter units of point: 1 in. 2 ft, 3 cm, 4 m ',$)
      READ(5,*)IUNIT
      WRITE(6,2)
    2 FORMAT(' Enter axis lower point ',$)
      READ(5,*)P1(1),P1(2),P1(3)
      WRITE(6,4)
    4 FORMAT(' Enter axis upper point ',$)
      READ(5,*)P2(1),P2(2),P2(3)
      WRITE(6,7)DIA1,DIA2,CUNIT(IUNIT),P1,P2
      WRITE(66,7)DIA1,DIA2,CUNIT(IUNIT),P1,P2
    7 FORMAT(' RCS of Truncated Cone',/,
     1' Lower & Upper Diameters:       ',F8.3,F8.3,A4,/,
     2' Axis Lower Point:              ',3F8.3,/,
     2' Axis Upper Point:              ',3F8.3)
      DO 6 I=1,3
      P1(I)=P1(I)*UNITS(IUNIT)
    6 P2(I)=P2(I)*UNITS(IUNIT)
      DIA1=DIA1*UNITS(IUNIT)
      DIA2=DIA2*UNITS(IUNIT)
      RAD1=DIA1/2.
      RAD2=DIA2/2.
      WRITE(6,8)
    8 FORMAT(' Enter current patch increment ',$)
      READ(5,*)PATCH
      ALINC=PATCH*UNITS(IUNIT)
      ICAT=0
      CALL CONEGEO(P1,P2,RAD1,RAD2,ALINC,19,ICAT)
      ICAT=1
      IF(DIA1.GT.0.)THEN
      CALL VLINC(1.,P1,-1.,P2,AXS)
      CALL RINGEO(AXS,0.,DIA1,P1,ALINC,19,ICAT)
      ENDIF
      IF(DIA2.GT.0.)THEN
      CALL VLINC(1.,P2,-1.,P1,AXS)
      CALL RINGEO(AXS,0.,DIA2,P2,ALINC,19,ICAT)
      ENDIF
      INOUT=1
      READ(19,REC=1)(IBUF(NN),NN=1,19)
      WRITE(6,9)IBUF(1)
    9 FORMAT(' Number of patches = ',I5)
      IF(IBUF(1).GT.4000)STOP
   11 WRITE(6,12)
   12 FORMAT(' Enter 0 stop, Vary: 1 Frequency, 2 Angle, 3 Bistatic ',$)
      READ(5,*)ITASK
      IF(ITASK.EQ.0)STOP
      WRITE(6,13)
   13 FORMAT(' Enter polarization: 1 Theta, 2 Phi ',$)
      READ(5,*)IPOL
      IF(IPOL.EQ.1)WRITE(66,14)
      IF(IPOL.EQ.2)WRITE(66,15)
   14 FORMAT(/,' Incident wave Theta polarized')
   15 FORMAT(/,' Incident wave Phi polarized')
      IF(ITASK.NE.2)THEN
      WRITE(6,16)
   16 FORMAT(' Enter incident angles (Theta,Phi) w.r.t. Z-axis ',$)
      READ(5,*)THETA,PHI
      WRITE(66,17)THETA,PHI
   17 FORMAT(' Incident wave direction: Theta: ',F7.2,'  Phi: ',F7.2)
      CALL FFDIRC(THETA*TR,PHI*TR,VR,VT,VP)
      ENDIF
      IF(ITASK.NE.1)THEN
      WRITE(6,18)
   18 FORMAT(' Enter frequency (GHz) ',$)
      READ(5,*)FREQU
      PKC=2.*PI*FREQU/CC
      WRITE(66,19)FREQU
   19 FORMAT(' Frequency (GHz) = ',F8.3)
      WRITE(6,20)
   20 FORMAT(' Vary: 1 Phi, 2 Theta ',$)
      READ(5,*)IPAT
      IF(IPAT.EQ.1)THEN
      WRITE(6,21)
   21 FORMAT(' Enter Theta ',$)
      READ(5,*)THETA
      WRITE(66,22)THETA
   22 FORMAT(' Constant Theta = ',F7.2)
      ELSE IF(IPAT.EQ.2)THEN
      WRITE(6,23)
   23 FORMAT(' Enter Phi ',$)
      READ(5,*)PHI
      WRITE(66,24)PHI
   24 FORMAT(' Constant Phi = ',F7.2)
      ENDIF
      IF(IPOL.EQ.1)THEN
      HFIELD(1)=VP(1)
      HFIELD(2)=VP(2)
      HFIELD(3)=VP(3)
      ELSE
      HFIELD(1)=VT(1)
      HFIELD(2)=VT(2)
      HFIELD(3)=VT(3)
      ENDIF
      IF(ITASK.EQ.3.AND.IPOL.EQ.1)
     1 CALL REFPCU(PKC,VR,HFIELD,BLOCKN,XBB,19,INOUT)
      IF(ITASK.EQ.3.AND.IPOL.EQ.2)
     1 CALL REFPCU(PKC,VR,HFIELD,BLOCKN,XBB,19,INOUT)
      IF(ITASK.EQ.3)CALL CURCOM(19)
      ENDIF
      IF(ITASK.EQ.1)THEN
C  -------------------- Vary frequency
      WRITE(6,25)
   25 FORMAT(' Enter frequency (GHz)  start,stop,step ',$)
      ELSE
C  -------------------- Vary angle
      WRITE(6,26)
   26 FORMAT(' Enter angle  start,stop,step ',$)
      ENDIF
      READ(5,*)F1,F2,F3
      NF=(F2-F1)/F3+1.4
      IF(NF.GT.361)GOTO 11
      IF(ITASK.EQ.1)THEN
      WRITE(66,27)
      WRITE(6,27)
   27 FORMAT(' Frequency  RCS dBsm')
      ELSE IF(ITASK.EQ.2)THEN
      WRITE(66,28)
      WRITE(6,28)
   28 FORMAT(' Backscatter',/,'  Angle   RCS dBsm')
      ELSE IF(ITASK.EQ.3)THEN
      WRITE(66,29)
      WRITE(6,29)
   29 FORMAT(' Bistatic Scattering',/,'  Angle   RCS dBsm')
      ENDIF
      DO 30 I=1,NF
      FREQ(I)=F1+FLOAT(I-1)*F3
      IF(ITASK.NE.1)THEN
      IF(IPAT.EQ.1)THEN
      PH=FREQ(I)*TR
      TH=THETA*TR
      ELSE
      PH=PHI*TR
      TH=FREQ(I)*TR
      ENDIF
      ENDIF
      IF(ITASK.EQ.1)PKC=2.*PI*FREQ(I)/CC
      IF(ITASK.EQ.2)CALL FFDIRC(TH,PH,VR,VT,VP)
      IF(ITASK.NE.3)THEN
      IF(IPOL.EQ.1)THEN
      HFIELD(1)=VP(1)
      HFIELD(2)=VP(2)
      HFIELD(3)=VP(3)
      ELSE
      HFIELD(1)=VT(1)
      HFIELD(2)=VT(2)
      HFIELD(3)=VT(3)
      ENDIF
      CALL REFPCU(PKC,VR,HFIELD,BLOCKN,XBB,19,INOUT)
      CALL CURCOM(19)
      ENDIF
      CALL FFPATR(XC,BLOCKN,XBB,TH,PH,ETHETA,EPHI)
      IF(IPOL.EQ.1)RCS(I)=20.*ALOG10(RCONS*CABS(ETHETA))
      IF(IPOL.EQ.2)RCS(I)=20.*ALOG10(RCONS*CABS(EPHI))
      IF(ITASK.EQ.1)WRITE(66,31)FREQ(I),RCS(I)
      IF(ITASK.EQ.1)WRITE(6,31)FREQ(I),RCS(I)
      IF(ITASK.NE.1)WRITE(66,32)FREQ(I),RCS(I)
      IF(ITASK.NE.1)WRITE(6,32)FREQ(I),RCS(I)
   30 CONTINUE
   31 FORMAT(F9.4,F10.2)
   32 FORMAT(F7.2,F10.2)
      WRITE(6,33)
   33 FORMAT(' Plot? ',$)
      IF(NYES(K).EQ.1)CALL RCPLT(FREQ,RCS,NF)
      GOTO11
      END
