      SUBROUTINE NORMP(P,FOC,RNORM)
C
C  Unit Normal to Paraboloidal Reflector at Point P, Focal Length FOC
C
      DIMENSION RNORM(1),P(1)
      AL=SQRT(P(1)**2+P(2)**2+4.*FOC**2)
      RNORM(1)=-P(1)/AL
      RNORM(2)=-P(2)/AL
      RNORM(3)=2.*FOC/AL
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
