      FUNCTION PATBEAM(BL,BN,NAPPR)
C
C  Pattern Approximation  I: E = cos(Theta/2)**N  Beamwidth (degrees)
C                        II: E = cos(Theta)**N
C
C  BL      Beamwidth level dB
C  BN      Pattern exponent
C  NAPPR   Approximation number
C
      DATA TR/.01745329/
      PATBEAM=4.*ACOS(10.**(-ABS(BL)/(20.*BN)))/NAPPR/TR
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
