      FUNCTION SHADOW(ANORM,XS,XF)
C
C  Shadow: Field only if reflector normal toward the current
C
C  ANORM(3)   Normal to surface
C  XS(3)      Source point (current)
C  XF(3)      Field point (reflector surface)
C
      DIMENSION ANORM(1),XS(1),XF(1),XTT(3)
      CALL VLINC(1.,XF,-1.,XS,XTT)
      SHADOW=0.
      IF(DOT(ANORM,XTT).GT.0.)SHADOW=1.
C ------ Antenna Engineering using Physical Optics, Artech
C ------ Code by T.A. Milligan
      RETURN
      END
