% MATLAB script file for calculating far-field
% patterns of open-ended waveguide
%
% PART c: currents at open-ended guide
%

Mxp=cos(pi*xsp/wx);	% Nsxp by 1 array, x' mag current density
Mxa=Mxp*Iy;		% Nsxp by Nsyp array, x' mag current den
Msu=reshape(Mxa,Ns,1)*ut1 ;% Ns by 3 array, x mag currents den
Pm=1/2/Z0*sum(abs(dot01(Msu,Msu'.')).*dS);
Ms=Msu/sqrt(Pm).*(dS*ones(1,3));	% current in Volt*meter

Jyp=cos(pi*xsp/wx);	% Nsxp by 1, y' elect current density
Jya=Jyp*Iy;		% Nsxp by Nsyp, y' elect current den
Jsu=reshape(Jya,Ns,1)*ut2;% Ns by 3 array, y elect current den
Pe=1/2*Z0*sum(abs(dot01(Jsu,Jsu'.')).*dS);
Js=Jsu/sqrt(Pe).*(dS*ones(1,3));	% current in Amp*meter

%